package dcsp;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;
import javax.swing.plaf.basic.*;
import java.awt.*;
import java.awt.event.*;

class AgentGUI extends JFrame {
    JButton bExit = new JButton("Exit");
    JButton bRun = new JButton("Run");
    JButton bStep = new JButton("Step");
    JButton bReset = new JButton("Problem Reset");
    JButton bParticipate = new JButton("Participate");
    JButton bLoad;
    //JTextField editName = new JTextField(20);
    JFileChooser fileLoader;
    JLabel label;
    JLabel fileLabel;
    String sLabel="Last loaded file : ";
    String fixFileLab="   ";
    String noneLabel="none                                    ";
    String fLabel;
    Agent agent;
    AgentGUI(String title, Agent _agent){
	super(title);
	agent = _agent;
	try {
	    UIManager.setLookAndFeel(
				     //		  UIManager.getCrossPlatformLookAndFeelClassName());
				     "com.sun.java.swing.plaf.windows.WindowsLookAndFeel"); 
	} catch (Exception e) {
	    System.err.println("No win look&feel");
	}

	bExit.setMnemonic(KeyEvent.VK_X);
	bExit.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("agent GUI-EXIT!");
		System.err.println("agent GUI-EXIT!");
		System.exit(0);
	    }
	});
	bRun.setMnemonic(KeyEvent.VK_R);
	bRun.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Agent Start...");
		agent.run();
	    }
	});
	bParticipate.setMnemonic(KeyEvent.VK_R);
	bParticipate.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Agent Participate...");
		agent.participate();
	    }
	});
	bStep.setMnemonic(KeyEvent.VK_R);
	bStep.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Agent Step...");
		agent.step();
	    }
	});
	bReset.setMnemonic(KeyEvent.VK_S);
	bReset.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Problem Reset...");
		agent.problemReset();
		fileLabel.setText(fixFileLab+noneLabel);
	    }
	});
	ImageIcon saveIcon = new ImageIcon("dcsp/images/save.gif");
	fileLoader=new JFileChooser("./");
	fileLoader.setApproveButtonText("Load");
	fileLoader.setApproveButtonMnemonic(KeyEvent.VK_L);
	fileLoader.setApproveButtonToolTipText("Load the selected problem file");
	javax.swing.filechooser.FileFilter problemFilter=new ProblemFilter();
	fileLoader.addChoosableFileFilter(problemFilter);
	fileLoader.setFileFilter(problemFilter);
        bLoad = new JButton("Load", saveIcon);
       	bLoad.setMnemonic(KeyEvent.VK_L);
	bLoad.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Loading...");
		fileLoader.setApproveButtonText("Load");
		fileLoader.setApproveButtonMnemonic(KeyEvent.VK_L);
		int returnVal = fileLoader.showOpenDialog(AgentGUI.this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
		    File file = fileLoader.getSelectedFile();
		    if(agent.loadFile(file)){
			fLabel=file.getName();
			fileLabel.setText(fixFileLab+fLabel);
		    }
		    System.out.println("Opening: " + file.getName() + ".");
		} else {
		    System.err.println("Open command cancelled by user.");
		}
	    }
	});
	JPanel pane = new JPanel();
	pane.setBorder(BorderFactory.createEmptyBorder(10, 30, 10, 30));
	pane.setLayout(new GridLayout(4, 1));
	pane.add(bRun);
	pane.add(bStep);
	pane.add(bReset);
	pane.add(bExit);
	JPanel tpane = new JPanel();
	tpane.setBorder(BorderFactory.createEmptyBorder(10, 30, 10, 30));
	tpane.setLayout(new GridLayout(1, 1));
	tpane.add(bParticipate);
	
	JPanel fpane = new JPanel();
	fpane.setBorder(BorderFactory.createEmptyBorder(30, 30, 0, 30));
	fpane.setLayout(new BorderLayout());
	fpane.add(bLoad,BorderLayout.SOUTH);
	
	label=new JLabel(sLabel);
	fileLabel = new JLabel(fixFileLab+noneLabel);
	fpane.add(label,   BorderLayout.NORTH);
	fpane.add(fileLabel,   BorderLayout.CENTER);

	getContentPane().add(fpane,BorderLayout.NORTH);
	getContentPane().add(pane,BorderLayout.CENTER);
	getContentPane().add(tpane,BorderLayout.SOUTH);
	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		System.out.println("windowClosing:exit");
		System.err.println("windowClosing:exit");
		System.exit(0);
	    }
	});
	pack();
	setVisible(true);
    }
    public void loaded(File file){
	fLabel=file.getName();
	fileLabel.setText(fixFileLab+fLabel);
    }
} 
