package dcsp;
import java.util.*;

class AgentGraph{
    AgentData ad;
    boolean mark=false;
    ArrayList followers=new ArrayList();
    ArrayList precedence=new ArrayList();
    AgentGraph(AgentData _ad){
	ad=_ad;
    }
    AgentData getAD(){
	return ad;
    }
    // assumes parameter not already in
    void addLink(AgentGraph ag){
	followers.add(ag);
	ag.precedence.add(this);
	System.out.println("addLink from:"+ad.name+" to:"+ag.ad.name);
    }
    void markFollowers(){
	if(mark) return;
	mark=true;
	for(int k=0;k<followers.size();k++){
	    ((AgentGraph)followers.get(k)).markFollowers();
	}
    }
    void freeFollowers(ArrayList adds){
	//System.out.println("freeFollowers:size of:"+followers.size());
	for(int k=0;k<followers.size();k++){
	    // System.out.println("freeFollowers:deal with k:"+k);
	    AgentGraph ag=(AgentGraph)followers.get(k);
	    //System.out.println("freeFollowers:deal with:"+ag.ad.name);
	    if(ag.mark){
		System.err.println("freeFollowers:Already marked:"+ag.ad.name+" while freeing:"+ad.name);
		continue;
	    }
	    int pos=ag.precedence.indexOf(this);
	    if(pos<0){
		System.err.println("freeFollowers:not found in precedence of:"+ag.ad.name+" while freeing:"+ad.name);
	    }
	    ag.precedence.remove(pos);
	    if(ag.precedence.size()==0){
		ag.mark=true;
		adds.add(ag);
	    }
	}
    }
    boolean first(){
	return precedence.size()==0;
    }
}
