package dcsp;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class BrokerGUI extends JFrame {
    JButton bExit = new JButton("Exit");
    JButton bRun = new JButton("Run Search");
    JButton bStep = new JButton("Step Through");
    JButton bClear = new JButton("Clear Search");
    JButton bTests = new JButton("Start Tests");
    JComboBox cProtocol = new JComboBox();
    JLabel lprotocol = new JLabel();
    String tprotocol = " Protocol :      ";
    final String defaultp= "Default";
    final String yokoo= "_ABT_";
    final String cyokoo= "C_ABT_";
    final String iyokoo= "I_ABT_";    
    final String uyokoo= "U_ABT_";    
    Broker broker;
    BrokerGUI(String title, Broker _broker){
	super(title);
	broker = _broker;
	try {
	    UIManager.setLookAndFeel(
		  UIManager.getCrossPlatformLookAndFeelClassName());
	} catch (Exception e) { }

	bExit.setMnemonic(KeyEvent.VK_X);
	bExit.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("broker GUI-EXIT!");
		broker.exit(0);
	    }
	});
	bRun.setMnemonic(KeyEvent.VK_R);
	bRun.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Server Start...");
		broker.run();
	    }
	});
	bTests.setMnemonic(KeyEvent.VK_T);
	bTests.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Server Tests...");
		broker.tests();
	    }
	});
	bStep.setMnemonic(KeyEvent.VK_S);
	bStep.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Step through...");
		broker.step();
	    }
	});
	bClear.setMnemonic(KeyEvent.VK_C);
	bClear.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		System.out.println("Clearing Session...");
		broker.clearSession("Administrator clear request");
	    }
	});
	JPanel pane = new JPanel();
	pane.setBorder(BorderFactory.createEmptyBorder(10, 30, 10, 30));
	pane.setLayout(new GridLayout(3, 1));
	pane.add(bRun);
	pane.add(bClear);
	pane.add(bExit);

	JPanel tpane = new JPanel();
	tpane.setBorder(BorderFactory.createEmptyBorder(10, 30, 30, 30));
	tpane.setLayout(new GridLayout(2, 1));
	tpane.add(bTests);
	tpane.add(bStep);

	JPanel cpane = new JPanel();
	cpane.setBorder(BorderFactory.createEmptyBorder(30, 30, 10, 30));
	cpane.setLayout(new GridLayout(2, 1));
	cProtocol.addItem(defaultp);
	cProtocol.addItem(yokoo);
	cProtocol.addItem(cyokoo);
	cProtocol.addItem(uyokoo);
	cProtocol.addItem(iyokoo);
	cProtocol.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		if(broker.protocol.equals((String)cProtocol.getSelectedItem())){
		    System.out.println("Already set");
		    return;
		}
		if("Default".equals((String)cProtocol.getSelectedItem()))
		    broker.setProtocolGUI();
		else
		    broker.setProtocolGUI((String)cProtocol.getSelectedItem());
	    }
	});
	lprotocol.setText(tprotocol);
	cpane.add(lprotocol);
	cpane.add(cProtocol);

	getContentPane().add(pane,BorderLayout.CENTER);
	getContentPane().add(cpane,BorderLayout.NORTH);
	getContentPane().add(tpane,BorderLayout.SOUTH);
	addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {
		System.out.println("EXIT-windowClosung");
		System.err.println("EXIT-windowClosung");
		System.exit(0);
	    }
	});
	pack();
	setVisible(true);
    }
    void setProtocol(String _protocol){
	if(_protocol.equals(defaultp)){
	    cProtocol.setSelectedIndex(0);
	    System.out.println("Setting "+_protocol);
	    return;
	}
	if(_protocol.equals(yokoo)){
	    cProtocol.setSelectedIndex(1);
	    System.out.println("Setting "+_protocol);
	    return;
	}
	if(_protocol.equals(cyokoo)){
	    cProtocol.setSelectedIndex(2);
	    System.out.println("Setting "+_protocol);
	    return;
	}
	if(_protocol.equals(uyokoo)){
	    cProtocol.setSelectedIndex(3);
	    System.out.println("Setting "+_protocol);
	    return;
	}
	if(_protocol.equals(iyokoo)){
	    cProtocol.setSelectedIndex(4);
	    System.out.println("Setting "+_protocol);
	    return;
	}
	System.out.println("Not found: "+_protocol);
    }
} 
