package dcsp;
import dcsp.parameters.*;
import java.rmi.*;
import java.rmi.server.*;
import java.net.*;

class BrokerServer extends UnicastRemoteObject implements IBrokerServer {
    static DInt roundID=new DInt(0);
    static void oneWaySend(IAgentServer target, String command, Object params) throws RemoteException{
	target.oneWayMessage(command,params,(Object)roundID);
    }
    static void oneWaySend(IBrokerServer target, String command, Object params) throws RemoteException{
	target.oneWayMessage(command,params,(Object)roundID);
    }
    static Object messageSend(IAgentServer target, String command, Object params) throws RemoteException{
	return target.message(command,params,(Object)roundID);
    }
    Broker broker;
    BrokerServer(Broker _broker) throws RemoteException, MalformedURLException{
	super();
	broker= _broker;
    }
    private boolean waitCommand(Object k){
	synchronized(roundID){
	    while(((DInt)k).val>roundID.val){
		try{
		    roundID.wait(10000);
		}catch(Exception e){
		    e.printStackTrace();
		    System.err.println("BrokerServer:waitCommand");
		    return false;
		}
	    }
	    if(((DInt)k).val<roundID.val)
		return false;
	}
	return true;
    }
    private int upToDateCommand(String command, Object k){
	System.out.println("Position incoming:"+((DInt)k).val+" old:"+roundID.val);
	if(command.equals("PARTICIPATE")) {
	    synchronized(roundID){
		roundID.val=((DInt)k).val;
		roundID.notifyAll();
	    }
	}
	if(((DInt)k).val<roundID.val){
	    System.out.println(command+" Outdated");
	    return -1;
	}
	if(((DInt)k).val==roundID.val){
	    System.out.println(command+" UpToDate");
	    return 0;
	}
	return 1;
    }
    public Object message(String command, Object parameters, Object sID) throws RemoteException{
	System.out.print("Server: "+command);
	if (parameters != null)
	    System.out.println(" "+parameters.toString());
	System.out.println("");
	//
	int status=upToDateCommand(command,sID);
	if(status<0)
	    return null;
	if(status>0){
	    if(!waitCommand(sID))
		return null;
	}
	//
	try {
	    return broker.message(command, parameters);
	}
	catch (Exception e) {
	    e.printStackTrace();
	    return null;
	}
    }
    public void oneWayMessage(String command, Object parameters, Object sID) throws RemoteException{
	//
	int status=upToDateCommand(command,sID);
	if(status<0)
	    return;
	if(status>0){
	    if(!waitCommand(sID))
		return;
	}
	//
	OneWayThread omMessage=new OneWayThread(this);
	omMessage.setMessage(command, parameters,new DInt(roundID.val));
	omMessage.start();
    }
}
