package dcsp;
import dcsp.parameters.Range;
import dcsp.parameters.DCost;

class Cover2 implements Cover {
    int tab[][];
    int dim[]=new int[2];
    String vars[];
    int[] score; //direction scores, loaded by extend, expandable, expand
    Cover2(C2Representation mat){
        int[][] _tab=mat.getMatrix();
	if(_tab==null){
	    System.err.println("Cover2:Null Matrix!!");
	    dim[0]=dim[1]=0;
	}else{
	    dim[0]=_tab.length;
	    if(dim[0]>0)
		dim[1]=_tab[0].length;
	    else dim[1]=0;
	}
        tab= new int[dim[0]][dim[1]];
   
        Refresh(mat);
    }
    public void init(CRepresentation mat){
        Refresh((C2Representation)mat);
    }
    boolean expandable(Range[] box, int direction, int value){
        System.out.println("expandable:Checking dir:"+direction+" value:"+value);
        Range tmp=box[direction];
        box[direction]=new Range(value);
        for(int k=box[0].getL();k<=box[0].getU();k++){
	    int first=box[1].getL(),last=box[1].getU();
	    if(!chk(k,last)){ //edges first
		box[direction]=tmp;
		return false;
	    }
	    for(int kk=first;kk<last;kk++)
		if(!chk(k,kk)){
		    box[direction]=tmp;
		    return false;
		}
	}
        box[direction]=tmp;
        return true;
    }
    boolean excessive(Range[] box, Range[] domain, int direction, int value){
        Range tmp=box[direction];
        box[direction]=new Range(value);
        int k,x;
        System.out.println("excessive:Checking direction:"+direction);
        for(k=0;k<2;k++){
	    // if(k==direction)continue;
	    // do not matter if expandable
	    //  on bigger directions
	    if(score[k]>=score[direction]){
		System.out.println("excessive:Direction not interesting:"+k);
		continue;//direction ingrata
	    }
	    if((x=box[k].getL()-1)>=domain[k].getL())
		if(expandable(box,k,x)){
		    box[direction]=tmp;
		    System.out.println("excessive: found");
		    return true;
		}
	    if(domain[k].getU()>=(x=box[k].getU()+1))
		if(expandable(box,k,x)){
		    box[direction]=tmp;
		    System.out.println("excessive: found");
		    return true;
		}
	}
        box[direction]=tmp;
        System.out.println("excessive: not found");
        return false;
    }
    public void setScore(int[] _score){
        score=_score;   
    }
    // ? excess tells if the excess is bothering (variab importance) true if this is not the first direction. 
    public void expand(Range[] box, Range[] domain, int direction, boolean excess){ 
	//...;k<dim[direction];...
	int k=box[direction].getU()+1;
	System.out.println("Expanding in direction "+direction+" between:"+k+" and "+domain[direction].getU());
        for(;k<=domain[direction].getU();k++){
	    System.out.println("Dealing with k="+k);
	    if(excess && excessive(box,domain,direction,k)){
		// excess exists & is bothering
		System.out.println("Excess on direction "+direction);
		return;
	    }
	    if(!expandable(box,direction,k))
		return;
	    box[direction].setU(k);
	    System.out.println("Expanded direction: "+direction+" value: "+k);
        }
    }
    boolean chk(int a, int b){
        System.out.println("verify: ["+a+","+b+"]");
	((DCost)Utils.agentCost).incrementChecks();
	System.out.println(((DCost)Utils.agentCost).toString());
        return tab[a][b]==1;
    }
    public boolean good(int[] i, int[] reorder){
        return chk(i[reorder[0]],i[reorder[1]]);
    }
    public boolean findIn(Range[] result, Range[] domain, Scanable region){
        final int dim=2;
        int dim1= dim-1;
        int dim2= dim-2;
        int[] order=region.getOrder();
        System.out.println("Setting first search order ["+order[0]+","+ order[1]+" ]");
        int[] reorder=region.getReorder();
        System.out.println("Setting first search reorder ["+reorder[0]+","+ reorder[1]+" ]");
        Range[] searchField=new Range[dim];

        boolean[] firstRun=new boolean[dim];
        firstRun[0]=firstRun[1]=true;

        System.out.println("Domain:");
        Print(domain);
        System.out.println("Region:");
        region.regionPrint();
        searchField[0]=region.restrict((Range)domain[0].clone(),0);
        searchField[1]=region.restrict((Range)domain[1].clone(),1);
        System.out.println("Search field:");
        Print(searchField);
        
        int[] i=new int[dim];
        i[dim1]=searchField[order[dim1]].getL();
        int s0=region.getStartPoint(order[dim1]);
        System.out.println("Start Point s0="+s0);
        if(i[dim1]<=s0){
	    i[dim1]=s0;
	}else //we are jumping to a later value, all the
	    //other starting points should be disabled
	    firstRun[1]=false;
	System.out.println("Start Point s0<-"+i[dim1]);
        int upper0=searchField[order[dim1]].getU();
	// if we will however jump to the next
	if(i[dim1]>upper0)
	    firstRun[1]=false;
        for(;i[dim1]<=upper0;i[dim1]++){
            System.out.println("i["+dim1+"]=" + i[dim1]);
            int upper1=searchField[order[dim2]].getU();
            i[dim2]=searchField[order[dim2]].getL();
            if(firstRun[1]){
                firstRun[1]=false;
                int s1=region.getStartPoint(order[dim2]);
                System.out.println("Start Point s1="+s1);
                if(i[dim2]<s1)
                    i[dim2]=s1;
            }
            for(;i[dim2]<=upper1;i[dim2]++){
                System.out.println("i["+dim2+"]=" + i[dim2]);
                if(good(i,reorder)){
                    result[order[dim1]]=new Range(i[dim1]);
                    result[order[dim2]]=new Range(i[dim2]);
                    //?region.setFirst(i0,i1);
                    return true;
                }
            }
        }
	System.out.println("findIn:Search space exausted");
        return false;
    }
    int printTrials=0;
    public void Print(){
	if(printTrials>2){
	    System.err.println("Cover2:Print:Too many IllegalMonitorStateException");
	    printTrials=0;
	    return;
	}
	if(tab==null){
	    System.out.println("Cover2:empty");
	    return;
	}
	try {
	    for(int k=0;k<tab.length;k++){
		for(int kk=0;kk<tab[k].length;kk++)
		    System.out.print(tab[k][kk]+" ");
		System.out.println("");
	    }
	    System.out.println("");
	} catch (IllegalMonitorStateException e){
	    // a bug of java
	    e.printStackTrace();
	    System.err.println("Cover2:Print:IllegalMonitorStateException");
	    printTrials++;
	    Print();
	}
	printTrials=0;
    }
    private void Print(Range[] dom){
        for(int k=0;k<dom.length;k++){
           System.out.println("["+dom[k].getL()+"\t,"+dom[k].getU()+"\t]");
        }
    }
    void Refresh(C2Representation mat){
        int[][] _tab=mat.getMatrix();
        for(int k=0;k<_tab.length;k++)
            tab[k]=(int[])_tab[k].clone();
    }
    void Refresh(C2Representation mat, Range[] range){
        int[][] _tab=mat.getMatrix();
        for(int k=range[0].getL();k<=range[0].getU();k++)
            for(int kk=range[1].getL();k<=range[1].getU();kk++)
                tab[k][kk]=_tab[k][kk];
    }
    public void mark(Range[] range){
	if(range.length<2)
	    System.err.println("Bad range length:"+range.length);
        int up0=range[0].getU();
        int up1=range[1].getU();
        int k=range[0].getL();
        for(;k<=up0;k++){
            int kk=range[1].getL();
            for(;kk<=up1;kk++){
                tab[k][kk]=0;
            }
        }
    }
}
