package dcsp;
import java.util.*;
import dcsp.parameters.*;

interface IYConstraint {
    // resets the constraint ensuring that all the good
    // combinations are still allowed and findable
    void initCover();
    // returns the rearch global id for the index-th
    // variable of this constraint
    int getID(int index);
    // Nr of variables
    int getVariablesNr(); 
    // returns the index-th variable
    String getVariable(int index);
    boolean getNextBox(Range[] result, Range[] domain);
    void setOrder(int[] _score, int[] _order, int[] _invorder);
    boolean haveID(int id);
    void setID(int index,int id);
    // Reset the Cover to only this box
    void resetMark(Range[] box);
    // reconsider all (configuration changed)
    void resetContinuationPoints();
    // for Nogoods
    void initDomain(Range[] domain);
    // print debugging info
    void Print();
}
