package dcsp;
import java.io.Serializable;
import dcsp.parameters.*;
import java.util.*;

class OutgoingAgent implements Serializable {
    IAgentServer agent;
    public boolean ready=false;
    public ArrayList variables=new ArrayList();
    public Hashtable solution=new Hashtable();
    OutgoingAgent(IAgentServer ag){
	agent=ag;
    }
    public String toString(){
	String s="";
	s=s+"ready="+(ready?"T":"F");
	if(variables!=null){
	    s=s+":variables=";
	    for(int k=0;k<variables.size();k++)
		s=s+variables.get(k)+":";
	}
	if(solution!=null)
	    s=s+"NonEmpty solution";
	return s;
    }
    public String toString(DSearch dSearch){
	String s="";
	s=s+"ready="+(ready?"T":"F");
	if((agent!=null)&&(dSearch!=null)){
	    Hashtable pA=dSearch.problemByAgent;
	    if(pA!=null){
		AgentData ad=(AgentData)pA.get(agent);
		if((ad!=null)&&(ad.name!=null))
		    s=s+":Name="+ad.name;
	    }
	}
	if(variables!=null){
	    s=s+":variables=";
	    for(int k=0;k<variables.size();k++)
		s=s+variables.get(k)+":";
	}
	if(solution!=null)
	    s=s+"Solution size="+solution.size();
	return s;
    }
    public IAgentServer getAgent(){
	return agent;
    }
    public void insert(String var){
	variables.add(var);
    }
}
