package dcsp;
import java.util.*;
import java.io.*;
import dcsp.parameters.*;

class SetOfVariables {
    Hashtable vars = new Hashtable();
    Problem problem;
    SetOfVariables(Problem _problem){
	problem=_problem;
    }
    public boolean contains(String s){
	return vars.get(s)!=null;
    }
    public int getVariablesNr(){
	return vars.size();
    }
    public int getOwner(String variable){
	return ((ERange)vars.get(variable)).getOwner();
    }
    public SVariable[] getSVariables(){
	int varNr=getVariablesNr();
	String v;
	int owner;
	Iterator keys;
	SVariable[] svars= new SVariable[varNr];
	keys = (Iterator) vars.keys();
	for(int vcrt=0;vcrt<varNr;vcrt++){
	    v = (String) keys.next();
	    owner=((ERange)vars.get(v)).getOwner();
	    svars[vcrt]=new SVariable(v,owner>0);
	    //System.out.println("var "+svars[vcrt].getSVariable());
	}
	return svars;
    }
    public Range getRange(String v){
	try{
	    Range d=(Range) vars.get(v);
	    return new Range(d.getL(),d.getU());
	}catch (Exception e){
		System.err.println("Variable not found");
	}
	return null;
    }
    public int getSize(String var){
	try{
	    Range d=(Range) vars.get(var);
	    return d.getU()-d.getL()+1;
	}catch (Exception e){
	    System.err.println("Variable not found");
	}
	return 0;
    }
    public String loader(RandomAccessFile fis, int fileType){
	String v;
	int low,up;
	int owner=0;
      
	v=Utils.getString(fis);
	low=Utils.getInt(fis);
	up =Utils.getInt(fis);
	if(fileType!=0)
	    owner =Utils.getInt(fis);
	if(vars.containsKey(v)){
	    System.out.println("OldVar: "+v+":["+low+","+up+"]");
	    return v;
	}
	vars.put(v,new ERange(low,up,owner));
	System.out.println("NewVar: "+v+":["+low+","+up+"], owner: "+owner);
	return v;
    }
    /*
    public boolean colorLoader(RandomAccessFile fis,int count)
    {
	String v;
	int low,up;
	int crtv;
	for(crtv=0;crtv<count;crtv++)
	    {
		v=Utils.getString(fis);
		low=Utils.getInt(fis);
		up =Utils.getInt(fis);
		if(vars.containsKey(v))
		    continue;
		vars.put(v,new Range(low,up));
		System.out.println("NewVar: "+v+":["+low+","+"]");
	    }
	return true;
    }
    */
}
