package dcsp;
import java.util.*;
import dcsp.parameters.*;


class SynchronSolverThread extends Thread {
    Problem problem;
    int variablesNr;
    int constraintsNr;
    Range[][] domains=new Range[0][0]; //var stack
    String[] variables; //pointers to variables
    Hashtable vIDs=new Hashtable();
    Constraint[] constraints;
    int[] order;

    SynchronSolverThread(Problem _problem)
    {
	problem=_problem;
    }
    public void run()
    {
	init();
	DCPR();
    }
    void init()
    {
	buildDomainStack();
	buildConstraintReferences();
    }
    void buildDomainStack()
    {
	SVariable[] svariables;
	SetOfVariables sv;
	sv=problem.getSetOfVariables();
	svariables=sv.getSVariables();
	variablesNr=svariables.length;
	       //nr of vars = sv.getVariablesNr();
	constraintsNr=problem.getSetOfConstraints().getConstraintsNr();
	domains=new Range[variablesNr][constraintsNr+1];
	//System.out.println("Having: "+variablesNr+" variables and "+constraintsNr+" constraints");
	variables=new String[variablesNr];
	for(int k=0;k<variablesNr;k++)
	    {
		variables[k]=svariables[k].getSVariable();
		//System.out.println("dealing with variable "+variables[k]);
		vIDs.put(variables[k],new IntObject(k));
		domains[k][0]=sv.getRange(variables[k]);
	    }
    }
    // Nr of constraints already stated
    void buildConstraintReferences()
    {
	int k; //counter
	SetOfConstraints sc=problem.getSetOfConstraints();
	constraintsNr=sc.getConstraintsNr();
	constraints=sc.getConstraints();
	order=new int[constraintsNr];
	for(k=0;k<constraintsNr;k++)
	    {
		order[k]=k;
		int vcrt,vNr,vID;
		vNr=constraints[k].getVariablesNr();
		for(vcrt=0;vcrt<vNr;vcrt++)
		    {
			String vName;
			vName=constraints[k].getVariable(vcrt);
			vID=((IntObject)vIDs.get(vName)).getInt();
			constraints[k].setID(vcrt,vID);
		    }
	    }
    }
    void DCPR()
    {
	DCPR(0);
    }
    void DCPR(int ccrt)
    {
	/*
	if(LastConstraint(ccrt))
	    {
		//solution report ok()
		return;
	    }
	PushDomains();
	ReOrderVariables();
	while GetNextBox(ccrt)
	    {
		LoadDomains();
		UpdateDomains();
		ReOrderConstraints(ccrt);
		DCPR(ccrt+1);
	    }
	PopDomains();
	*/
    }
}
