package dcsp;
import java.util.ArrayList;
import java.util.Random;
import java.io.*;

class TestLeader{
    ArrayList agents= new ArrayList();
    Broker broker;
    boolean solvingEnd=true;
    int subscripted=0;
    int cleaned=0;
    // size of the agents
    int size=0;
    Object solving=new Object();
    Object subscription=new Object();
    Object participation=new Object();
    Object cleaning=new Object();
    String protocols[];

    int graph[][];
    int used[];
    int color[];
    boolean domain[][];
    int nr_var, nr_col, min_dens, tightness;
    Random rgen= new Random();
    RandomAccessFile crtFile, solFile;


    TestLeader(Broker _broker){
	broker=_broker;
    }
    void add(IAgentServer _agent){
	synchronized(participation){
	    if (agents.indexOf(_agent)<0){
		agents.add(_agent);
		System.out.println("New agent participates, now:"+agents.size());
	    }else
		System.out.println("Existing agent");
	}
    }
    int nrOfTests=50;
    void test(){
	protocols=broker.getProtocols();
	size=agents.size();
	System.out.println("Size is:"+size);
	for(int k=0;k<nrOfTests;k++){
	    System.out.println("New test..");
	    tightness=35;
	    //int GenerateProblem(int size, int colors, float dens, int minD, int densOfDomains, int setOfTests){
	    GenerateProblem(size,8,(float)3,3,10,k);
	    System.out.println("Problem created");
	    openSolutionFile(k);
	    System.out.println("File Solution"+k+" created");
	    if(protocols==null){
		System.err.println("EXIT:protocols==null");
		System.exit(1);
	    }
	    for(int protocolID=0; protocolID<protocols.length; protocolID++){
		BrokerServer.roundID.val=k*protocols.length+protocolID;
		broker.setProtocol(protocols[protocolID]);
		printSol("PROTOCOL "+protocols[protocolID]+"\n\n");
		synchronized(subscription){
		    subscripted=0;
		}
		synchronized(cleaning){
		    cleaned=0;
		}
		// distribute problem(request remote subscription)
		for(int ag=0; ag<size; ag++){
		    broker.distribute((IAgentServer)agents.get(ag),getName(k,ag));
		}
		synchronized(subscription){
		    while(subscripted<size){
			// wait 'size' subscriptions
			try{
			    subscription.wait();
			}catch(InterruptedException e){
	    e.printStackTrace();
	    System.err.println("TestLeader:test");
			}
		    }
		}
		System.out.println("Subscription got");
		synchronized(solving){
		    solvingEnd=false;
		    System.out.println("Subscription run");
		    broker.run();
		    //timer set;
		    if(!solvingEnd)
			try{
			    solving.wait();
			}catch(InterruptedException e){
			    e.printStackTrace();
			    System.err.println("TestLeader:solving!!");
			};
		    //timer got;
		}
		synchronized(cleaning){
		    while(cleaned<size){
			// wait 'size' subscriptions
			try{
			    cleaning.wait();
			}catch(InterruptedException e){}
		    }
		}
	    }
	    closeSolutionFile();
	}
    }
    void clean(){
	synchronized(cleaning){
	    cleaned++;
	    System.out.println("got "+cleaned+" cleaned of "+size);
	    if(cleaned>=size)
		cleaning.notifyAll();
	}	
    }
    void endSolving(String result){
	synchronized(solving){
	    if(solvingEnd){
		System.out.println("Already End Solving");
		return;
	    }
	    printSol(result+"\n");
	    System.out.println("End Solving");
	    solvingEnd=true;
	    solving.notifyAll();
	}
    }
    void subscribe(){
	synchronized(subscription){
	    subscripted++;
	    System.out.println("got "+subscripted+" subscriptions of "+size);
	    if(subscripted>=size)
		subscription.notifyAll();
	}
    }
    int aleat(int nr_up){
	int k=rgen.nextInt(nr_up);
	//System.err.println("random to "+nr_up+":"+k);
	return k;
    }

    int linked(int n1, int n2){
	int v1,v2,tmp,j;
	if(used[n1]>used[n2]){
	    v2=n1; tmp=used[v1=n2];
	}else {
	    v2=n2; tmp=used[v1=n1];
	}
	for(j=0;j<tmp; j++)
	    if(graph[v1][j]==v2){
		//System.err.println("Already linked "+n1+" "+n2);
		return 1;
	    }
	//System.err.println("Not yet linked "+n1+" "+n2);
	return 0;
    }

    int link(int i, int j){
	if((used[i]>=nr_var-1)||(used[j]>=nr_var-1)){
	    //System.err.println("Imposible to link "+i+" "+j);
	    return 0;
	}
	graph[i][used[i]++]=j;
	graph[j][used[j]++]=i;
	//System.err.println("linked "+i+" "+j);
	return 1;
    }
    // try a color link
    int tryitlimited(int source, int start, int direction, int nr_var){
	int upaccepted;
	int src=source;
	int srcm1=src-1;
	if (srcm1<0) 
	    srcm1= -srcm1;
	while (used[source]==nr_var-1){
	    if (source%nr_var==(srcm1)%nr_var){
		//System.err.println("Sources exausted at:"+src+" while "+source%nr_var+" eq "+(srcm1)%nr_var);
		return 0;
	    }
	    //System.err.println("Sources not exausted at:"+src+" while "+source%nr_var+" !eq "+(srcm1)%nr_var+" given:"+nr_var);
	    source++;
	    if (source>=nr_var)
		source=0;
	    //System.err.println("Try new source:"+source+" of:"+src);
	}
	//System.err.println("new source:"+source);
	upaccepted=min_dens;
	//if initially min_dens>nr_var
	if(upaccepted>=nr_var)
	    upaccepted=nr_var-1;
	for ( ;upaccepted<nr_var; upaccepted++)
	    if(upaccepted!=nr_var-1)
		upaccepted++;
	    for(int k=0; k<2; k++){
		if(direction!=0){
		    for(int j=start;j>=0;j--)
			//if (color[j]!=color[source])
			if (j!=source)
			    if (used[j]<upaccepted)
				if (0==linked(j,source))
				    if (0!=link(j,source))
					return 1;
		}else
		    for(int j=start+1;j<nr_var;j++)
			//if (color[j]!=color[source])
			if (j!=source)
			    if (used[j]<upaccepted)
				if (0==linked(j,source))
				    if (0!=link(j,source))
					return 1;
		direction= (direction==0)?1:0;
	    }
	return 0;
    }
    
    int tryit(int source, int start, int direction, int nr_var){
	int src=source;
	int srcm1=src-1;
	if (srcm1<0) 
	    srcm1= -srcm1;
	while (used[source]==nr_var-1){
	    if (source%nr_var==(srcm1)%nr_var){
		//System.err.println("Sources exausted at:"+src+" while "+source%nr_var+" eq "+(srcm1)%nr_var);
		return 0;
	    }
	    source++;
	    if (source>=nr_var)
		source=0;
	}
	for(int k=0; k<2; k++){
	    if(direction!=0){
		for(int j=start;j>=0;j--)
		    //if (color[j]!=color[source])
		    if (j!=source)
			if (0==linked(j,source))
			    if (0!=link(j,source))
				return 1;
	    }
	    else
		for(int j=start+1;j<nr_var;j++)
		    //if (color[j]!=color[source])
		    if (j!=source)
			if (0==linked(j,source))
			    if (0!=link(j,source))
				return 1;
	    direction= (direction==0)?1:0;
	}
	return 0;
    }
    
    int GenerateProblem(int size, int colors, float dens, int minD, int densOfDomains, int setOfTests){
	//System.err.println("Problem"+size+" "+colors+" "+dens+" "+minD);
	nr_var=size;
	nr_col=colors;
	float avg_dens=dens;
	min_dens=minD;
	
	graph= new int[nr_var][nr_var-1];
	used= new int[nr_var];
	color= new int[nr_var];
	domain= new boolean[nr_var][nr_col];
	
	for(int k=0; k<nr_var; k++){
	    used[k]=0;
	    color[k]=aleat(nr_col);
	    System.err.println("domain of "+k);
	    for(int kk=0; kk<nr_col; kk++){
		int prob=aleat(100);
		domain[k][kk]=(prob>=densOfDomains);
		System.err.print((domain[k][kk]?1:0)+" ");
	    }
	    System.err.println("");
	    System.err.println("color for:"+k+"is"+color[k]);
	}

	int totalarcs=0;
	for(int v=0; v<nr_var; v++){
	    int colorstoadd=min_dens-used[v];
	    //System.err.println(colorstoadd+" colors to add to "+v);
	    for(int cols=0; cols<colorstoadd; cols++){
		int target=aleat(nr_var);
		int direction=aleat(2);
		//System.err.println("target "+target+" direction "+direction);
		if(0!=tryitlimited(v,target,direction,nr_var)){
		    totalarcs++;
		    System.err.println("arcs:"+totalarcs);
		}
		else
		    break;
	    }
	}
	
	int esec=0;
	int restarcs=(int)(nr_var*avg_dens/2) -totalarcs;
	int j;
	for(j=0; j<restarcs;){
	    if (esec>10)
		break;
	    if(0!=tryit(aleat(nr_var), aleat(nr_var),aleat(2),nr_var))
		j++;
	    else
		esec++;
	}
	restarcs=j;
	//print(nr_col).print("\n");
	//print(nr_var).print("\n");
	// print each variable;
	for(int u=0; u<nr_var; u++){
	    setOutput(setOfTests,u);
	    print("COLOR_V1").print("\n");
	    //print constraintsNr at u
	    int cNr=getConstraintsNr(u);
	    print(cNr+1).print(" # constraints\n");
	    printUConstraint(u);
	    for(int v=0; v<used[u]; v++){
		int varID=graph[u][v];
		if(varID<u){
		    // variables at u, v
		    int vNr=2;
		    print(vNr).print(" # variables\n");
		    print("v").print(u).print(" 0 ").print(domainSize(u)-1).print(" 1\n");
		    print("v").print(varID).print(" 0 ").print(domainSize(varID)-1).print(" -1\n");
		    printConstraint(u,varID);
		}
	    }
	    closeOutput();
	}
	return 0;
    }
    int domainSize(int v){
	int k, size=0;
	for (k=0; k<nr_col; k++)
	    if(domain[v][k])
		size++;
	return size;
    }
    int getConstraintsNr(int v){
	int cNr=0;
	for(int k=0; k<used[v]; k++)
	    if(graph[v][k]<v)
		cNr++;
	return cNr;
    }
    void printConstraint(int v, int u){
	int i,j,ic,jc; //ic, vc counter to check the bug
	for(ic=i=0;i<nr_col;i++){
	    if(!domain[v][i])
		continue;
	    ic++;
	    for(jc=j=0;j<nr_col;j++){
		if(!domain[u][j])
		    continue;
		jc++;
		//print((i!=j)?1:0).print(" ");
		print((aleat(100)<tightness)?1:0).print(" ");
		//print((aleat(nr_col)<nr_col-2)?1:0).print(" ");
	    }
	    if(jc!=domainSize(u)){
		System.err.println("printConstraint:EXIT-BOOM1");
		System.exit(11);
	    }
	    print("\n");
	}
	if(ic!=domainSize(v)){
	    System.err.println("printConstraint:EXIT-BOOM2");
	    System.exit(11);
	}
	print("\n");
    }
    void printUConstraint(int v){
	// variables at u, v
	int vNr=1;
	print(vNr).print(" # variables\n");
	int maxVal=domainSize(v)-1;
	print("v").print(v).print(" 0 ").print(maxVal).print(" 1\n");	
	for(int k=0;k<=maxVal; k++)
	    print("1 ");
	print("\n\n");
    }

    String getName(int set,int k){
	return "problem"+set+"p"+k;
    }

    void setOutput(int set,int k){
	String fname=getName(set,k);
	try{
	    crtFile=new RandomAccessFile(fname,"rw");
	    crtFile.setLength(0);
	}catch(Exception e){
	    System.err.println("error opening file "+set+" "+k);
	}
    }
    void openSolutionFile(int k){
	String fname="Solution"+k;
	try{
	    solFile=new RandomAccessFile(fname,"rw");
	    solFile.setLength(0);
	    solFile.writeBytes("Solution"+k+"\n");
	}catch(Exception e){
	    System.err.println("error opening sol file "+fname);
	}
    }
    void closeSolutionFile(){
	try{
	    solFile.close();
	}catch(Exception e){
	    System.err.println("error closing file");
	}
    }
    void closeOutput(){
	try{
	    crtFile.close();
	}catch(Exception e){
	    System.err.println("error closing file");
	}
    }
    TestLeader print(Object o){
	try{
	    crtFile.writeBytes(o+"");
	}catch(Exception e){
	    System.err.println("error writting to file");
	}
	System.out.print(o);
	return this;
    }
    TestLeader printSol(Object o){
	try{
	    solFile.writeBytes(o+"");
	}catch(Exception e){
	    System.err.println("error writting to file");
	}
	System.out.print(o);
	return this;
    }
    TestLeader print(int o){
	try{
	    crtFile.writeBytes(o+"");
	}catch(Exception e){
	    System.err.println("error writting to file");
	}
	System.out.print(o);
	return this;
    }
}
