package dcsp;
import dcsp.parameters.*;
import java.util.*;
import java.rmi.*;

class _ABT_Solver extends Solver{
    _ABT_SolverThread process;
    IBrokerServer broker;
    IAgentServer myself;
    String myName;
    int crtMyselfPosition;
    // cost of the current computation
    public DCost agentCost=new DCost();
    // cost buit to declare solution
    DCost acceptedCost=new DCost();
    // cost of messages
    final DCost messageCost=(new DCost()).setMessages();
    Problem problem;
    boolean nogoodAlreadySent=false;
    // used by the LAST messege 
    // to store the target of the nogoods
    IAgentServer last_target;
    // structure needed to compute LAST
    DSearch dSearch;
    // history_id for internal variables
    int[] historyIDs;
    // add history at each ok
    // update at nogoods if needed (not yet implemented)
    // put(String=var,DVarHistory=history)
    Hashtable varHistory=new Hashtable();
    // ArrayList outgoing=new ArrayList();
    // put(agent,(OutgoingAgent)ready:variables:lastSolution)
    Hashtable outGoing=new Hashtable();
    // used only to compute heuristic
    // do not contain dynamically added links
    // put((String)variable:(ArrayList=[IAgentServer])outgoing)
    Hashtable extDependency=new Hashtable();
    // put((String)varCrt:(VarHistory)sent)
    Hashtable lastSent=new Hashtable();
    ArrayList waitedLinks =new ArrayList();
    
    Range[] lastSolution; //variable:intervals
    // has the inComing already sent his value?
    // put(agent,signaled_ready=IntObject)
    Hashtable inComing=new Hashtable();
    // active nogoods reffered by external/original variable
    // put((String)variable:(ArrayList:YConstraint)nogoods,crtRange)
    // nogoods may be empty if no nogood was stored
    Hashtable extVariables=new Hashtable();
    final IntObject no_signaled=new IntObject(0);
    final IntObject signaled=new IntObject(1);
    final Range emptyRange=new Range(-1,-2);
    
    class ExternalRequest {
	String name;
        boolean go=false;
        private int isset=0;
	ExternalRequest(String _name){
	    name=_name;
	}
        synchronized void free(){
	    go=true;
	}
        synchronized boolean isFree(){
	    return go;
	}
        synchronized void busy(){
	    go=false;
	}
        synchronized void set(){
            isset++;
	    System.out.println("Setting request: "+isset);
        }
        synchronized void reset(){
            isset--;
	    System.out.println("Resetting request: "+isset);
        } 
        synchronized boolean request(){
	    System.out.println(name+" Requests nr: "+isset);
	    if(isset>0)
		System.out.println("There are requests");
            return isset>0;
        }
    }
    ExternalRequest externalRequest=new ExternalRequest("externalRequest");
    ExternalRequest gotOutgoing=new ExternalRequest("gotOutgoing");
    Object nogoodTarget=new Object();
    // monitor of incoming messages working on
    // the search thread
    Object modifyProcess=new Object();
    Object iAmReady=new Object();

    _ABT_Solver(Problem _problem){
        problem=_problem;
        myself=problem.getAgent().getSkel();
	myName=problem.getAgent().name;
        broker=problem.getAgent().broker;
        historyIDs=new int[problem.getVariablesNr()];
        for(int k=0;k<historyIDs.length;k++)
            historyIDs[k]=-1;

	Utils.agentCost=agentCost;
        process=new _ABT_SolverThread(problem,this);
	((DInt)process.searchID).val=problem.owner.skel.roundID.val;
    }
    public Object message(String command, Object parameters){
        if(command.equals("OK?")){
            ok((DView)parameters);
            return null;
        }
        if(command.equals("NOGOOD")){
            nogood((DNogood)parameters);
            return null;
        }
        if(command.equals("ADDLINK")){
            addLink((DAddLink)parameters);
            return null;
        }
        if(command.equals("LAST")){
            last_target=(IAgentServer)parameters;
            synchronized(nogoodTarget){
		nogoodTarget.notify();
	    }
            return null;
        }
        if(command.equals("ACCEPTED")){
            accepted((DAccepted)parameters);
            return null;
        }
        if(command.equals("START_LINKS")){
            registerStartLinks((DStartLinks)parameters);
            return null;
        }
        if(command.equals("STOPSEARCH")){
            System.out.println("Session reset because of: \""+((DString)parameters).get()+"\"");
            try {
		stopSession();
	    }catch (Exception e){
		e.printStackTrace();
	    }
            System.out.println("Session stopped");
            return new DOk();
        }
        System.err.println("Unknown command "+command);
        return null;
    }
    void registerStartLinks(DStartLinks parameters){
	registerInComing(parameters.dIncomingAgent.get());
	if(parameters.dSearch!=null)
	    dSearch=parameters.dSearch;
	else 
	    System.err.println("Empty dSearch!!");
	registerOutGoing(parameters.dOutgoingAgent.get());

	System.out.println("registerStartLinks: waits for gotOutgoing");
        synchronized (gotOutgoing){
	    gotOutgoing.set();
	    gotOutgoing.notifyAll();
	}
    }
    public void setParams(Object parameters){
	crtMyselfPosition=((DStartSearch)parameters).position;
	System.out.println("setPosition:My position:"+crtMyselfPosition);
    }
    // adding incoming link request
    void addLink(DAddLink parameters){
	if(!waitOutGoing())
	    // interrupted
	    return;
	System.out.println("addLink: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.set();
            try {
                if(!externalRequest.isFree())
                    externalRequest.wait();
            }
            catch (InterruptedException e){
		System.err.println("_ABT_Solver:addLink:interrupted!!");
                System.err.println(e);
		e.printStackTrace();
		return;
            }
        }
	System.out.println("addLink: waits for modifyProcess");
        synchronized(modifyProcess){
	    //System.out.println("Updating agentCost with agentCost");
	    //agentCost.updateCost(parameters.cost.incrementMessages(messageCost));
	    System.out.print("Contiguity test-addLink:..");
	    addLinkModifyingProcess(parameters);
            System.out.println("..addLink-End test");
        }
        //..........
	System.out.println("addLink: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.reset();
            ////perhaps the solve thread
            externalRequest.notify(); 
        }
    }
    void addLinkModifyingProcess(DAddLink link){
	boolean newRequests=false;
	System.out.println("addLinkModifyingProcess: In");
        ArrayList variables=getCommonVariables(link.variables);
        if(variables==null){
	    System.out.println("addLinkModifyingProcess: No common variable:Leaving");
	    return;
	}
	agentCost.updateCost(link.cost.incrementMessages(messageCost));
        OutgoingAgent oa=(OutgoingAgent)outGoing.get(link.source);
        if(oa==null){
	    System.out.println("addLinkModifyingProcess: outGoing.get(link.source)==null");
            oa=new OutgoingAgent(link.source);
            oa.variables=variables;
            outGoing.put(link.source,oa);
	    newRequests=true;
        }else{
	    // Should be unique!
	    for(int k=0;k<variables.size();k++){
		String s=(String)variables.get(k);
		if(!oa.variables.contains(s)){
		    System.out.println("addLinkModifyingProcess: new s="+s);
		    oa.variables.add(s);
		    newRequests=true;
		}else
		    System.out.println("addLinkModifyingProcess: old s="+s);
	    }
            //oa.variables.addAll((Collection)variables);
            outGoing.put(link.source,oa);
        }
	if(!newRequests){
	    System.out.println("addLinkModifyingProcess: No new variable: Leaving");
	    return;
	}
        Hashtable vIDs=process.getvIDs();
        DVarHistory dVarHistory;
	DView answer= new DView();
	for(int k=0; k<variables.size();k++){
	    String s=(String)variables.get(k);
	    int id=((IntObject)vIDs.get(s)).getInt();
	    System.out.println("addLinkModifyingProcess: building s="+s+" id="+id);
	    dVarHistory=(DVarHistory)lastSent.get(s);
	    if(dVarHistory==null){
		if((lastSolution==null)||(lastSolution[id]==null)||(lastSolution[id]==emptyRange)){
		    System.out.println("addLinkModifyingProcess: using getBaseRange, empty Solution at "+s);
		    dVarHistory=new DVarHistory((Range)process.getBaseRange(id));
		}else{
		    System.out.println("addLinkModifyingProcess: using lastSolution at "+s);
		    dVarHistory=new DVarHistory(lastSolution[id]);
		}
		dVarHistory.history=buildNewHistory(s,id);
		System.out.println("addLink:sending new, but not putting it in lastSent");
		//lastSent.put(s, dVarHistory);
	    }
	    answer.put(s,dVarHistory);
	}
	try {
	    answer.cost=(DCost)agentCost.clone();
	    answer.setAgent(myself);
	    answer.senderName=myName;
	    System.out.println("addLink:sending OK? "+answer);
	    AgentServer.oneWaySend(link.source,"OK?",answer,process.searchID);
	} catch(RemoteException e){
	    e.printStackTrace();
	}
	/*
        //extDependency used only for search heuristic
        if(lastSolution==null)
            return;// no solution yet
        boolean differences[]=new boolean[problem.getVariablesNr()];
	for(int k=0;k<differences.length;k++)
	    differences[k]=false;
        Hashtable vIDs=process.getvIDs();
        Enumeration vars=vIDs.keys();
        // this cycle may be done only for the
        // variables in "variables"
        while(vars.hasMoreElements()){
            String s=(String)vars.nextElement();
            int id=((IntObject)vIDs.get(s)).getInt();
            differences[id]=variables.contains(s);
	    System.out.println("Difference should be dependent of history for:"+s+" id:"+id);
	    differences[id]=true;
        }
        DView difVars=different(variables,lastSolution,vIDs,differences);
        if(difVars!=null){
            try {
		difVars.cost=(DCost)agentCost.clone();
                difVars.setAgent(myself);
		difVars.senderName=myName;
                AgentServer.oneWaySend(link.source,"OK?",difVars,process.searchID);
            } catch(RemoteException e){
                e.printStackTrace();
            }
	}
	*/
    }
    // get common variables with the incoming ones
    ArrayList getCommonVariables(String[] vars){
        ArrayList result=new ArrayList();
        SetOfVariables vset=problem.getSetOfVariables();
        // checks all incoming variables
        for(int k=0;k<vars.length;k++)
            // if the current one is owned
            if(vset.contains(vars[k]))
                result.add(vars[k]);
        return result;
    }
    // called by YNogood at deactivation
    void decrNogoods(String var){
	((ExtVariable)extVariables.get(var)).activeNogoods--;
    }
    void setGuilty(String var){
	System.out.println("setGuilty:var="+var);
	((ExtVariable)extVariables.get(var)).guilty=true;
    }
    void incrNogoods(String var, Range range){
	ExtVariable eVar;
	eVar=(ExtVariable)extVariables.get(var);
	if(eVar==null){
	    eVar=new ExtVariable();
	    // we may need to implement these
	    eVar.range=range;
	    eVar.nogoods=null;
	}
	eVar.activeNogoods++;
	extVariables.put(var,eVar);
    }
    public Object getRestart(){
        return externalRequest;
    }
    void freeAllThreads(){
	externalRequest.free();
	externalRequest.notifyAll();
    }
    // wait a message while the current problem is solved
    public void waitSignal() throws InterruptedException{
        externalRequest.free();
        try {
            // it will be notified at the end
            if(!externalRequest.request()){
		if(process.theEnd){
		    //freeAllThreads();
		    throw new InterruptedException();
		}
		externalRequest.wait();
	    }
            while(externalRequest.request()){
		System.out.println("Servs requests");
		serveExternalRequests();
	    }
        }catch (InterruptedException e){
	    externalRequest.busy();
	    process.theEnd=true;
	    //freeAllThreads();
	    throw e;
	}
        externalRequest.busy();
    }
    public void serveExternalRequests() throws InterruptedException{
        externalRequest.notify();
        System.out.println("Should serve requests-in error case waits 50s");
        externalRequest.wait(50000);
        System.out.println("Should have served requests");
    }
    public boolean serveIfRequested(){
	System.out.println("serveIfRequested: waits for externalRequest");
        synchronized (externalRequest) {
            if(!externalRequest.request())
                return false;
            else
                while(externalRequest.request())
                    {
                        try {
                            serveExternalRequests();
                        }
                        catch (InterruptedException e)
                            {
                                //break; serve threads
				// else we would get some zombies
                            }
                    }
            //externalRequest.reset();
            return true;
        }
    }
    public void Solve(){
        process.start();
    }
    void sendNogood(){
	if(nogoodAlreadySent){
	    System.out.println("sendNogood:Nogood already sent");
	    return;
	}
        if(!waitOutGoing())
	    // interrupted
	    return;
        DNogood params;
        String[] guiltyV;
        /* guilty variables are all those whose 
           domains are externally instantiated inside the
           nogoods reported from outgoing.
           As well, all those externally restricting our choice
           >>> If box would run, then only 
           restriction above box are interesting<<<<!!!!!!!!!!!!!
        */
	System.out.println("sendNogood:getGuiltyVariables");
        guiltyV=getGuiltyVariables();
        /* prepares parameters
           returns a Hashtable
        */
	System.out.println("sendNogood:getNogood");
        params=getNogood(guiltyV);
        /* target agent computed by the broker as
           the last in order within 
           the broker knowledge
        */
        //targetAgent returnned by getLast
        try {
            IAgentServer target;
	    target=getLastSender(params);
	    if(target==null){
		System.out.println("Use getLast to find last agent using variables in nogood");
		target=getLast(guiltyV);
	    }
            if(target!=null){
		negateIncoming(target);
		params.cost=(DCost)agentCost.clone();
		params.senderName=myName;
		System.err.println("sending NOGOOD: "+params);
                AgentServer.oneWaySend(target,"NOGOOD", params,process.searchID);
	    }
            else{
		System.out.println("sending EMPTYNOGOOD: "+agentCost);
                AgentServer.oneWaySend(broker,"EMPTYNOGOOD",agentCost,process.searchID);
	    }
	    // setting a flag to avoid resending
	    // before a new view is gotten
	    nogoodAlreadySent=true;
        }
        catch(RemoteException e){
	    e.printStackTrace();
	}
    }

    IAgentServer getLastSender(DNogood nogood){
	IAgentServer result;
	int crtLast=-1;
	if(nogood==null)
	    return null;
	if(nogood.view==null)
	    return null;
	Iterator it=nogood.view.values().iterator();
	while(it.hasNext()){
	    DVarHistory dv=(DVarHistory)it.next();
	    if(dv.history==null)
		return null;
	    if((dv.history.length==0)||(dv.history.length%2>0))
		return null;
	    int cl=dv.history[dv.history.length-2];
	    if(cl>crtLast)
		crtLast=cl;
	}
	if(crtLast<0)
	    return null;
	if((dSearch==null)||(dSearch.sortedAgents==null))
	    return null;
	IAgentServer[] array=(IAgentServer[])dSearch.sortedAgents;
	if(array.length<=crtLast)
	    return null;
	System.out.println("getLastSender:last position is="+crtLast);
	result=array[crtLast];
	return result;
    }

    // the procedure of receiving a nogood
    void nogood(DNogood dnogood){
	System.out.println("nogood: waits for externalRequest");
	System.err.println("Got NOGOOD:"+dnogood.toString());
        synchronized (externalRequest) {
            externalRequest.set();
            try {
                if(!externalRequest.isFree())
                    // process running
                    externalRequest.wait();
            }catch (InterruptedException e){
		System.err.println("_ABT_Solver:nogood");
                System.err.println(e);
		e.printStackTrace();
		return;
            }
        }
	System.out.println("nogood: waits for modifyProcess");
        synchronized(modifyProcess){
	    //System.out.println("Updating agentCost with incoming nogood agentCost");
	    agentCost.updateCost(dnogood.cost.incrementMessages(messageCost));
	    System.out.print("Contiguity test-nogood:..");
	    System.out.println("Processing nogood..");
	    //the array of guilty agents and the one
	    // currently processed 
	    IAgentServer guiltyA[], agent; 
	    // build the parameters of an eventually new OK? sent tu itself
	    Hashtable newOk=new Hashtable();
	    ArrayList newVars= new ArrayList();
	    int rang=dnogood.rang; 
	    System.out.println("Nogood rank:"+dnogood.rang);
	    // check if worthy of insert ()
	    // however, it is rechecked in process
	    if(insertConstraint(dnogood, newOk, newVars)){
		// insert in up to date
		//accomplishInsertion(dnogood,0);
		process.nogood(dnogood, 0, (Object)newOk);// where =0
		// insert nogood
		//System.out.println("Inserted");
	    } else
		process.nogood(dnogood, -1, (Object)newOk);
	    //call broker to get incoming agents
	    Hashtable view=dnogood.view;
	    if(newVars.size()>0){
		String[] newVarsArray=(String[])newVars.toArray(new String[0]);
		guiltyA=getAgents(newVarsArray);
		// interrupted waiting OutGoing
		if(guiltyA==null)
		    return; //interrupted || null
		// for All agents
		for(int k=0;k<guiltyA.length;k++){ 
		    agent=guiltyA[k];
		    // add link
		    addLink(agent, newVarsArray);
		    // ok? that disable the dependency, should do it! should erase the constraint
		}
	    } else
		System.out.println("No new variable required");
	    // System.out.println("Processing nogood..");
            System.out.println("..nogood-ok");
	    if(newOk.size()>0){
		// Update history information
		sendOkToMyself(newOk);
	    }else
		System.out.println("No new view in nogood");
            System.out.println("..nogood-End test");
	}
        //..........
	System.out.println("nogood: waits for externalRequest2");
        synchronized (externalRequest) {
            externalRequest.reset();
            ////perhaps the solve thread
            externalRequest.notify(); 
        }       
    }
    // get the agents that could sent the variables in parameter
    IAgentServer[] getAgents(String[] newVarsArray){
        IAgentServer[] guiltyA=new IAgentServer[0];
        DGetAntecedents params=new DGetAntecedents();
        params.id=crtMyselfPosition;
        params.variables=newVarsArray;
	guiltyA=getAntecedents(params);
        /*try{
            System.out.println("getAgents: send GETANTECEDENTS:"+params);
            guiltyA=(IAgentServer[])broker.message("GETANTECEDENTS",params);
        }catch(RemoteException e){
            System.err.println("Error getting antecedents");
	    }*/
        return guiltyA;
    }
    // Update earlier the view seen in a nogood, by creating an OK? toward myself
    void sendOkToMyself(Hashtable view){
        System.out.println("sendOkToMyself: start");
	DView dv=new DView();
	dv.view=view;
	dv.agent=myself;
	dv.senderName="Myself";
	dv.cost=acceptedCost;
        System.out.println("sendOkToMyself: OK? "+dv.toString());
	okModifyingProcess(dv);
    }
    // Takes the view that was not known from nogood
    // Literally resemble with prematureNogood()
    void getNewStuff(DNogood dnogood, Hashtable newOk, ArrayList newVars){
        DVarHistory dKnownVarHistory,dIncomingVarHistory,dObtainedHistory;
	if(dnogood==null){
	    System.err.println("EXIT-getNewStuff:dnogood==null");
	    System.exit(1);
	}
        Hashtable view=dnogood.view;
	if(view==null){
	    System.err.println("EXIT-getNewStuff:view==null");
	    System.exit(1);
	}
        Iterator keys=(Iterator)view.keys();
	if(keys==null){
	    System.err.println("EXIT-getNewStuff:keys==null");
	    System.exit(1);
	}
        while(keys.hasNext()){
            String crtVar=(String)keys.next();
	    System.out.println("getNewStuff:crtVar="+crtVar);
            dKnownVarHistory=(DVarHistory)varHistory.get(crtVar);
            dIncomingVarHistory=(DVarHistory)view.get(crtVar);
	    if(dIncomingVarHistory==null){
		System.err.println("EXIT-getNewStuff:dIncomingVarHistory==null");
		System.exit(1);
	    }
            int id=process.getvID(crtVar);
            if(dKnownVarHistory==null){
		if((dIncomingVarHistory.history==null)||
		   (dIncomingVarHistory.history.length==0)||
		   (dIncomingVarHistory.history[0]!=crtMyselfPosition)){
		    // It means incoming not consequence of me
		    dObtainedHistory=extractNew(crtVar,dIncomingVarHistory,dKnownVarHistory);
		    if(dObtainedHistory!=null){
			newOk.put(crtVar,dIncomingVarHistory);
			System.out.println("getNewStuff:newOk.put("+crtVar);
		    }
		    if(id<0){
			newVars.add(crtVar);
			System.out.println("getNewStuff:newVars.add("+crtVar);
		    }
                }
                continue;
            }
	    if(id>=0)
		if(dIncomingVarHistory.crtConsequence(dKnownVarHistory,crtMyselfPosition,historyIDs[id])) continue;
            if(dKnownVarHistory.olderThan(dIncomingVarHistory)){
		dObtainedHistory=extractNew(crtVar,dIncomingVarHistory,dKnownVarHistory);
		if(dObtainedHistory!=null){
		    newOk.put(crtVar,dObtainedHistory);
		    System.out.println("getNewStuff:newOk.add("+crtVar);
		}
	    }
        }
    }
    // extracts the new information in a nogood in order tu build an Ok in function newStuff
    private DVarHistory extractNew(String var, DVarHistory incoming, DVarHistory known){
	// flag to signal if the history is changed
	boolean changed=false;
	int k;
	if(incoming==null){
	    System.err.println("Exit-extractNew:incoming==null");
	    System.exit(1);
	}
	if(incoming.history==null){
	    System.err.println("Exit-extractNew:incoming.history==null");
	    System.exit(1);
	}
	int hlen=incoming.history.length;
	for(k=0;k<hlen;k++,k++){
	    if(incoming.history[k]==crtMyselfPosition){
		// it was a consequence
		System.out.println("extractNew:was consequence");
		return null;
	    }
	    if(incoming.history[k]>crtMyselfPosition){
		changed=true;
		break;
	    }
	}
	if(k==0){
	    //empty history not acceptable for a nogood
	    System.out.println("extractNew:Empty history for "+var+" "+((changed)?"\"changed\"":"\"not changed\""));
	    // refuse to extract if all history is from ahead
	    return null;
	}
	if(!changed){
	    System.out.println("extractNew:not changed");
	    return incoming;
	}
	//changed
	//build result
	// arriving here is not recommended while
	// if any history has to be deleted,
	// then it should belong to an agent
	// between me and source. Therefore that
	// third agent should have been the target
	// of this nogood
	System.out.println("extractNew:changed!!");
	DVarHistory result=new DVarHistory((Range)incoming);
	result.history=new int[k];
	System.out.print("history["+k+"]:");
	for(int kk=0;kk<k;kk++){
	    result.history[kk]=incoming.history[kk];
	    System.out.print(":"+incoming.history[kk]);
	}
	System.out.println("");
	// Was not known at all
	if((known==null)||(known.olderThan(result))){
	    System.out.println("extractNew:modifying history");
	    // decrease the history in order to allow the real one to be treated
	    result.history[k-1]--;
	    System.out.println("history["+(k-1)+"]="+result.history[k-1]);
	    return result;
	}
	return null;
    }
    // checks if the nogood is applicable
    // -it is needed if is newer than existing info
    // else
    // -external existing variables within/= that range
    // -internal domains intersect range
    // else
    // if not, then (store by rang- if rang enough high)

    // newOk detects new staff
    // newVars detects new variables
    // the result is not important, while the tests
    // are redone in process.nogood
    private boolean insertConstraint(DNogood dnogood, Hashtable newOK, ArrayList newVars){
        getNewStuff(dnogood,newOK,newVars);
	/*ID1001*/
        return false;
    }
    // test if link exists
    boolean inIncoming(IAgentServer agent){
        return inComing.get(agent)!=null;
    }
    // requests AddLink and register inComing
    void insertDependency(IAgentServer agent, String[] newVars){
	boolean notLast=false;
	synchronized(waitedLinks){
	    // should not have arrived now
	    if(!inIncoming(agent)){
		if(waitedLinks.size()>0){
		    System.out.println("_ABT_Solver:insertDependency:waitedLinks:notLast=true");
		    notLast=true;
		}
		if(waitedLinks.indexOf(agent)<0){
		    System.out.println("_ABT_Solver:insertDependency:Adding agent to waitedLinks");
		    waitedLinks.add(agent);
		}
	    } else{
		System.out.println("_ABT_Solver:insertDependency:inIncoming:notLast=true");
		notLast=true;
	    }
	    //inComing.put(agent,no_signaled);
	}
	if((inComing.size()==0)&&(!notLast)) {
	    try{
		System.out.println("insertDependency: send REMOVE_END_AGENT:"+myself);
		AgentServer.oneWaySend(broker,"REMOVE_END_AGENT", myself,process.searchID);
	    }catch(RemoteException e){
		System.out.println("Not able to reach broker");
		e.printStackTrace();
		return;
	    }
	}
        DAddLink params=new DAddLink();
        params.source=myself;
	params.senderName=myName;
        params.variables=newVars;
	params.cost=acceptedCost;
        try{
            AgentServer.oneWaySend(agent,"ADDLINK",params,process.searchID);
        }catch(RemoteException e){
            System.err.println("_ABT_Solver:insertDependency:Add link error sending message");
	    e.printStackTrace();
	    return;
        }
    }
    DVarHistory getExtHist(String var){
	return (DVarHistory)varHistory.get(var);
    }
    private void addLink(IAgentServer agent, String[] newVars){
        // test if link exists
        //if(!inIncoming(agent)){ 
            // the dependency will
            // register inComing
            insertDependency(agent, newVars);
	//}
    }
    /* guilty variables are all those whose 
       domains are externally instantiated inside the
       nogoods reported from outgoing.
       As well, all those externally restricting our choice
       >>> If box would run, then only 
       restriction above box are interesting<<<<!!!!!!!!!!!!!!
    */
    String[] getGuiltyVariables(){
        ArrayList variables=new ArrayList();
        // add variables not implied in original constraint
	System.out.println("getGuiltyVariables:addExternalVariables");
        addExternalVariables(variables);
        // add original variables that are externally constrained
	System.out.println("getGuiltyVariables:addInternalRestrictingVariables");
        addInternalRestrictingVariables(variables);
        // return
        return (String[])variables.toArray(new String[0]);
    }
    // add to "variables" those not implied in 
    // the original constraint and implied in active nogoods
    void addExternalVariables(ArrayList variables){
        Enumeration extVar=extVariables.keys();
        String var;
	System.out.println("addExternalVariables: ...");
        while(extVar.hasMoreElements()){
            var=(String)extVar.nextElement();
	    System.out.println("addExternalVariables:var="+var);
	    if(varHistory.get(var)==null){
		System.out.println("addExternalVariables:!in.varHistory:var="+var);
		continue;
	    }
	    // if not guilty, skip
	    if(!((ExtVariable)extVariables.get(var)).guilty){
		System.out.println("addExternalVariables:!guilty:var="+var);
		continue;
	    }
	    // add if not already present
            if(!variables.contains(var)){
		System.out.println("addExternalVariables:!contains:var="+var);
                variables.add(var);
	    }else
		System.out.println("addExternalVariables:contains:var="+var);
        }
    }
    // add original variables that are externally constrained
    void addInternalRestrictingVariables(ArrayList variables){
        process.addInternalRestrictingVariables(variables);
    }
    /* prepares parameters
       returns a DNogood
    */
    int getRang(){
	return 0;
    }
    DNogood getNogood(String[] guiltyV){
	DVarHistory ev; //range of external variable
        DNogood nogood=new DNogood();
        Hashtable view=new Hashtable();
	System.out.println("getNogood:building nogood of size="+guiltyV.length);
        // for All guilty variables
        for(int k=0;k<guiltyV.length;k++){
            // external variables may contain also original ones
	    //int id;
	    //id=process.getvID(guiltyV[k]);
	    // put the current range of the External Variable
	    if(varHistory.get(guiltyV[k])!=null){
		ev=(DVarHistory)varHistory.get(guiltyV[k]);
		System.out.println("getNogood:adding varHistory "+guiltyV[k]+" as "+ev);
		view.put(guiltyV[k],ev);
		continue;
	    }
	    //if it is not in varHistory, then it do not exists or it is a guilty internal in a nogood
	    System.out.println("getNogood:rejecting unknown in varHist "+guiltyV[k]);
	    continue;
	    /* ID1000*/
	}
        nogood.rang=getRang();
        nogood.view=view;
        return nogood;
    }
    // ask for the last in order guilty agent
    IAgentServer getLast(String[] guiltyV) throws RemoteException{
        DGetLast params=new DGetLast();
        params.guiltyV=guiltyV;
        params.source=myself;
	return getLast(params);
	/*
        // synchronisation needed. Else, the answer and the notification may arrive before the wait is set
        try{synchronized(nogoodTarget){
            broker.oneWayMessage("GETLAST",params);
            System.out.println("Waiting the nogood target");
        // // if an OK comes
        //wait(OK || TARGET);
        //if(ok && situationChange)
        //    throw new OkIsHere();
            nogoodTarget.wait();}
        }catch(Exception e){
            System.out.println("Interrupted target");
            //e.printStackTrace();
            return null;}
        // the TARGET message will set this global variable
        System.out.println("Got the nogood target");
        return last_target;
	*/
    }
    // called if nothing in outGoing or 
    // at announce if all other outGoing finished
    // returns false for interrupted
    private boolean announcePartialSolution(){
	IAgentServer agent; // targets of ACCEPTED
	DAccepted dAccepted=new DAccepted();
	dAccepted.agent=myself;
	dAccepted.senderName=myName;
	dAccepted.history=IntersectionOfSolutions();
	if(dAccepted.history==null)
	    System.err.println("announcePartialSolution:Error in internal solution");
	System.out.println("Updating acceptedCost with agentCost");
	acceptedCost.updateCost(agentCost);
	dAccepted.cost=(DCost)acceptedCost.clone();
	if(dAccepted.empty()) {
	    if(process.constraintsNr>0){
		System.out.println("Empty intersection of Accepted");
		return true;
	    }else
		System.out.println("Empty Accepted!!");
	}
	System.out.println("announcePartialSolution: send ACCEPTED:"+dAccepted);
	synchronized(waitedLinks){
	    try{ 
		while(waitedLinks.size()>0){ 
		    waitedLinks.wait(); 
		} 
	    }catch(Exception e){ 
		System.err.println("_ABT_Solver:accepted:interrupted while waiting for addingLinkMonitor"); 
		e.printStackTrace(); 
		return false; 
	    }
	    if(inComing.isEmpty()){
		System.out.println("announcePartialSolution: send ACCEPTED: to broker");
		try{
		    AgentServer.oneWaySend(broker,"ACCEPTED",dAccepted,process.searchID);
		}catch(Exception e){
		    e.printStackTrace();
		    return false;
		}
		return true;
	    }
	    Iterator it=(Iterator)inComing.keys();
	    // for all incoming
	    while(it.hasNext()){
		agent=(IAgentServer)it.next();
		// history contains all the history he accepts
		try{
		    AgentServer.oneWaySend(agent,"ACCEPTED",dAccepted,process.searchID);
		}catch(RemoteException e){
		    e.printStackTrace();
		    return false;
		}
	    }
	}
	return true;
    }
    private Hashtable IntersectionOfSolutions(){
	Hashtable view=new Hashtable();
	if(!addInternalSolution(view))
	    return null;
	Iterator it=(Iterator)outGoing.keys();
	while(it.hasNext()){
	    System.out.println("Adding solution from outgoing");
	    addSolution(view,(OutgoingAgent)outGoing.get(it.next()));
	}
	return view;
    }
    // add the announced Solutions in outgoing
    // (they should be consequence...) 
    private void addSolution(Hashtable view, OutgoingAgent outgoing){
	DVarHistory solHist, outHist;
	Iterator it=(Iterator) outgoing.solution.keys();
	while(it.hasNext()){
	    String var=(String)it.next();
	    solHist=(DVarHistory)view.get(var);
	    outHist=(DVarHistory)outgoing.solution.get(var);
	    if(solHist==null)
		view.put(var,outHist.clone());
	    else{
		solHist.restrict(outHist);
	    }
	}
    }
    // add the personal solutions with the incoming history
    // the parameter is empty at input
    private boolean addInternalSolution(Hashtable view){
	String var;
	_ABT_SolverThread tmp=process;
	DVarHistory dVarHistory,oldHist;
	if(tmp==null)
	    return false;
	if(lastSolution==null){
	    System.err.println("addInternalSolution:lastSolution==null");
	    return false;
	}
	for(int k=0; k<lastSolution.length; k++){
	    var=tmp.getVariable(k);
	    if(lastSolution[k]==null)
		return false;
	    dVarHistory=new DVarHistory(lastSolution[k]);
	    oldHist=(DVarHistory)varHistory.get(var);
	    if(oldHist!=null){
		// the incoming history
		dVarHistory.history=oldHist.history;
	    }
	    System.out.println("Adding "+var+"=["+dVarHistory+"] to internal solution");
	    if((view!=null)&&(var!=null)&&(dVarHistory!=null))
		view.put(var,dVarHistory);
	}
	return true;
    }
    private void accepted(DAccepted parameters){
	if(!waitOutGoing()){
	    System.out.println("accepted:interrupted");
	    // interrupted
	    return;
	}
	// should be synchronized with the incoming OK? that change history
	synchronized(waitedLinks) {
	    // not really needed here, but however needed later-if here as well, perhaps the message becomes more valid:)
	    try{ 
		while(waitedLinks.size()>0){ 
		    waitedLinks.wait(); 
		} 
	    }catch(Exception e){ 
		System.err.println("_ABT_Solver:accepted:interrupted while waiting for addingLinkMonitor"); 
		e.printStackTrace(); 
		return; 
	    }
	}

	System.out.println("accepted: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.set();
            try {
                if(!externalRequest.isFree())
                    externalRequest.wait();
            }
            catch (InterruptedException e){
		System.err.println("_ABT_Solver:accepted:!!");
                System.err.println(e);
		e.printStackTrace();
		return;
            }
        }
	System.out.println("accepted: waits for modifyProcess");
        synchronized(modifyProcess){
	    System.out.print("Contiguity test-accepted:..");
	    acceptedModifyingProcess(parameters);
            System.out.println("..accepted -End test");
        }
        //..........
	System.out.println("accepted: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.reset();
            ////perhaps the solve thread
            externalRequest.notify(); 
        }
    }
    // at incoming ACCEPTED
    private void acceptedModifyingProcess(DAccepted accepted){
	// if the accepted history is the newest
	System.out.println("accepted: waits for varHistory");
	synchronized(varHistory){
	    if(!newestHistory(accepted.history)){
		System.out.println("accepted:!newestHistory");
		return;
	    }
	}
	IAgentServer agent=accepted.agent;
	((OutgoingAgent)outGoing.get(agent)).ready=true;
	((OutgoingAgent)outGoing.get(agent)).solution=accepted.history;
	// update cost
	//System.out.println("Updating acceptedCost with incoming acceptedCost");
	acceptedCost.updateCost(accepted.cost);
	// and if I am finished
	if(waitedLinks.size()==0) 
	    if(amIReady()){
		if(outGoingAllFinished()){
		    if(inComingAllFinished()){
			System.out.println("accepted:announce Further");
			if(!announcePartialSolution())
			    return;//interrupted
		    }else
			System.out.println("accepted:!inComingAllFinished");
		}else
		    System.out.println("accepted:!outGoingAllFinished");
	    }else
		System.out.println("accepted:!amIReady");
	System.out.println("accepted:end of message");
    }
    private boolean amIReady() {
	synchronized(iAmReady) {
	    return process.amIReady();
	}
    }
    // checked in order to send ACCEPTED
    private boolean outGoingAllFinished(){
	Iterator it=(Iterator)outGoing.keys();
	while(it.hasNext()){
	    IAgentServer agent=(IAgentServer)it.next();
	    OutgoingAgent oa=(OutgoingAgent)outGoing.get(agent);
	    if(!oa.ready) return false;
	}
	return true;
    }
    // disabled while several incoming never
    // send ranges as they are not restricting
    // checked in order to send ACCEPTED
    private boolean inComingAllFinished(){

    // disabled while several incoming never
    // send ranges as they are not restricting
	return true;
	/*
	Iterator it=(Iterator)inComing.keys();
	while(it.hasNext()){
	    IAgentServer agent=(IAgentServer)it.next();
	    IntObject io=(IntObject)inComing.get(agent);
	    // OK? on the nogoods are not compulsory
	    System.out.println("Should not wait OK? for inComing that are not original!!!!");
	    // until correct implementation
	    //return true;
	    if(io==no_signaled) return false;
	}
	return true;
	*/
    }
    // if the accepted history is the newest
    private boolean newestHistory(Hashtable view){
	if(view==null){
	    System.err.println("Accepted null view");
	    return false;
	}
	Iterator it=(Iterator)view.keys();
	String var; int id;
	IntObject io;
	DVarHistory acceptedHist, myHist; 
	Hashtable vIDs=process.getvIDs();
	while(it.hasNext()){
	    var=(String)it.next();
	    System.out.println("Checking variable "+var);
	    io=(IntObject)vIDs.get(var);
	    if(io==null){
		System.out.println("External variable");
		continue;
	    }
	    //myHist=(DVarHistory)varHistory.get(var);
	    myHist=(DVarHistory)lastSent.get(var);
	    acceptedHist=(DVarHistory)view.get(var);
	    id=io.getInt();
	    // if incoming is consequence, it is OK
	    int crtOrder=historyIDs[id];
	    System.out.println("Internal variable:"+crtOrder);
	    //if(acceptedHist.crtConsequence(myHist,crtMyselfPosition,crtOrder)) 
	    // now we need to have an older sent history
	    if(myHist==null)
		continue;
	    if(myHist.olderOrEqualThan(acceptedHist))
		continue;
	    // It is not consequence, nor external
	    System.out.println("!newestHistory:At variable:"+var);
	    myHist.printOlderOrEqualThan(acceptedHist);
	    return false;
	}
	return true;
    }
    boolean sameAsIncoming(Range range, String var){
	Range incom=(Range)varHistory.get(var);
	if(incom==null){
	    System.out.println("No incoming with:"+var);
	    return false;
	}
	System.out.println("Incoming was:"+incom);
	if(range.different(incom)){
	    System.out.println("Different:"+var+": incoming!="+range);
	    return false;
	}else {	
	    System.out.println("Same as incoming"+range);
	    return true;
	}
    }
    public void yokoo(boolean[] differences){
	for(int k=0;k<differences.length;k++)
	    if(differences[k]&&(!process.isOwner(k)))
		differences[k]=false;
    }
    // send OK?
    public void setSolution(Range[] domain, Hashtable vIDs){
	if(!waitOutGoing())
	    // interrupted
	    return;
	System.out.println("setSolution:Preparing OK?");
        boolean differences[]=new boolean[domain.length];
        // first solution report
        if (lastSolution==null){
	    System.out.println("setSolution:lastSolution==null");
            lastSolution=(Range[])domain.clone();
            for(int k=0;k<domain.length;k++){
		if(sameAsIncoming(domain[k],process.getVariable(k))){
		    System.out.println("SameAsIncoming->false "+k);
		    differences[k]=false;
		}else {
		    differences[k]=true;
		    System.out.println("!SameAsIncoming->true "+k);
		}
		// initially -1
		if(differences[k])
		    historyIDs[k]++;
		System.out.println("New history[k="+k+"]="+historyIDs[k]);
                lastSolution[k]=(Range)domain[k].clone();
            }
	    // yokoo do not send not owner
	    if(Utils.is_ABT_())
		yokoo(differences);
	}else{
	    System.out.println("setSolution:lastSolution!=null");
            for(int k=0;k<domain.length;k++){
		System.out.println("Checking differences for k="+k);
                differences[k]=domain[k].different(lastSolution[k]);
                if(differences[k]){
		    if(lastSolution[k]==emptyRange){
			System.out.println("lastSolution==emptyRange for k="+k);
			// if not restriction brought
			if(sameAsIncoming(domain[k],process.getVariable(k))){
			    differences[k]=false;
			    //continue;
			}
			System.out.println(process.getVariable(k)+" disabled by an OK?");
		    }
		    if(differences[k])
			historyIDs[k]++;
		    System.out.println("New history[k="+k+"]="+historyIDs[k]);
                    lastSolution[k]=(Range)domain[k].clone();
                }
            }
	    // yokoo do not send not owner
	    if(Utils.is_ABT_())
		yokoo(differences);
	}
	buildLastSent(differences, domain);
	// synchronized for the case that an addLink comes
	// followed by an accepted... meanwhile
	synchronized(iAmReady){
	    // The case where the outgoing not empty
	    // is treated at the receive of Accepted
	    if(outGoing.size()==0){
		System.out.println("No outgoing");
		// if OK? newer then nogoods
		// have arrived from all incoming
		process.setIAmReady();
		//if(inComingAllFinished())
		if(!announcePartialSolution()){
		    process.theEnd=true;
		}
		return;
	    }
	}
        IAgentServer agent;
        Iterator keys;
        keys = (Iterator) outGoing.keys();
	System.out.println("Start sending");
        int messagesSent=0;
	// if the answer to an OK? comes while sending
	// then it could lead to deadlock (being removed)
	// for no IAmReady
	synchronized(iAmReady){
	    while (keys.hasNext()){
		agent = (IAgentServer) keys.next();
		// null if no difference
		DView difVars=different(((OutgoingAgent)outGoing.get(agent)).variables,lastSolution,vIDs,differences);
		if(difVars!=null){
		    try {
			((OutgoingAgent)outGoing.get(agent)).ready=false;
			difVars.cost=(DCost)agentCost.clone();
			difVars.setAgent(myself);
			difVars.senderName=myName;
			AgentServer.oneWaySend(agent,"OK?",difVars,process.searchID);
			messagesSent++;
		    } catch(Exception e){
			e.printStackTrace();
		    }
		}else{
		    System.out.println("Empty difVars for this agent:"+agent);
		}
	    }
	    process.setIAmReady();
	    if(messagesSent==0){
		System.out.println("No message sent");
		// if OK? newer then nogoods
		// have arrived from all incoming
		if(inComingAllFinished()&&outGoingAllFinished()){
		    System.out.println("Announce solution");
		    if(!announcePartialSolution()){
			process.theEnd=true;
		    }
		    return;
		}
	    }
	}
    }
    // checks the history of the OK? and updates the current history
    Hashtable updateHistory(Hashtable view){
        Hashtable result=new Hashtable();
        Iterator keys=(Iterator)view.keys();
        String changed;
	ExtVariable eVar;
        DVarHistory olddVarHistory,newdVarHistory;
	System.out.println("Updating history");
        while (keys.hasNext()){
            changed=(String)keys.next();
            newdVarHistory=(DVarHistory)view.get(changed);
            olddVarHistory=(DVarHistory)varHistory.get(changed);
	    System.out.println("updateHist: deal with "+changed);
            if(olddVarHistory!=null){
		System.out.println("olddVarHistory!=null");
                if(olddVarHistory.olderThan(newdVarHistory)){
		    System.out.println("olddVarHistory olderThan newdVarHistory");
		    // if it is a local variable
		    int id=process.getvID(changed);
		    if(id>=0)
			if (lastSolution!=null){
			    historyIDs[id]=-1;
			    System.out.println("Updating History: lastSolution<-emptyRange");
			    lastSolution[id]=emptyRange;//make it different
			}
                }else{ // else remove from OK?
                    System.out.println("Outdated variable \""+changed+"\"discarded");
		    continue;
                }
            }else{
		// olddVarHistory==null
		// if it is a local variable
		int id=process.getvID(changed);
		if(id>=0)
		    if (lastSolution!=null){
			historyIDs[id]=-1;
			System.out.println("Updating History: lastSolution<-emptyRange");
			lastSolution[id]=emptyRange;//make it different
		    }
	    }
	    // execute the following for all accepted "changed"
	    varHistory.put(changed,newdVarHistory);
	    // maintaint extVariables...
	    eVar=(ExtVariable)extVariables.get(changed);
	    if(eVar==null){
		eVar=new ExtVariable();
	    }
	    eVar.range=(Range)newdVarHistory.clone();
	    extVariables.put(changed,eVar);
	    //.......
	    result.put(changed,newdVarHistory);
        }
        return result;
    }
    // should use extVariables to change the 
    // active-inactive nogoods
    // parameter (String:DVarHistory)
    private void reviewNogoods(Hashtable view){
        System.out.println("Should review nogoods");
	process.reviewNogoods(view);
    }
    // The part of the OK? processing that is synchronized
    private void okModifyingProcess(DView parameters){
	System.err.println("Got OK?: "+parameters.toString());
	Hashtable view=parameters.get();
	// synchronized registration of an OK?
	// in the inComing structure for ACCEPTED signaling
	registerIncoming((IAgentServer)parameters.getAgent());
	
	// Process only the newer variables if any
	Hashtable newView;
	// access synchronized with ACCEPTED
	//System.out.println("okModifyingProcess: waits for varHistory");
	synchronized(varHistory){
	    newView=updateHistory(view);
	}
	if(newView.size()>0){
	    process.registerModifyingMessage();
	    nogoodAlreadySent=false;
	    // this changes the domains
	    process.ok(newView);
		// Nothing is any longer guilty
		// The guilty ones are reset in process at return of handleRequests if expanded.
	        //resetGuilty();
	    // should use extVariables to change the 
	    // active-inactive nogoods
	    reviewNogoods(newView);
	}else
	    System.out.println("okModifyingProcess:Outdated ok");
    }
    // process incoming ok?
    // erase dependent nogoods 
    private void ok(DView parameters){
	System.out.println("ok: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.set();
            try {
                if(!externalRequest.isFree())
                    externalRequest.wait();
            }
            catch (InterruptedException e){
		System.err.println("_ABT_Solver:ok:!!");
                System.err.println(e);
		e.printStackTrace();
		return;
            }
        }
	System.out.println("ok: waits for modifyProcess");
        synchronized(modifyProcess){
	    //System.out.println("Updating agentCost with agentCost");
	    // updating here to avoid updating because of OkToMyself
	    agentCost.updateCost(parameters.cost.incrementMessages(messageCost));
	    System.out.print("Contiguity test-ok:..");
	    okModifyingProcess(parameters);
            System.out.println("..ok-End test");
        }
        //..........
	System.out.println("ok: waits for externalRequest");
        synchronized (externalRequest) {
            externalRequest.reset();
            ////perhaps the solve thread
            externalRequest.notify(); 
        }
    }
    // resets all the guilty in extVariables
    void resetGuilty(){
	System.out.println("resetGuilty:start...");
	Iterator it=(Iterator)extVariables.keys();
	while(it.hasNext()){
	    ((ExtVariable)extVariables.get((String)it.next())).guilty=false;
	}
    }
    // construieste istoria noului mesaj
    int[] buildNewHistory(String varCrt, int id){
        int[] newHistory, oldHistory;
        DVarHistory doldHistory;
        int k=0;
        doldHistory=(DVarHistory)varHistory.get(varCrt);
        if(doldHistory!=null){
	    oldHistory=doldHistory.history;
            if(oldHistory==null){
                 newHistory=new int[2];
                 System.out.println("null history pointer");
            }else{
                newHistory=new int[2+oldHistory.length];
                for(k=0;k<oldHistory.length;k++){
		    System.out.println("Adding to "+varCrt+".history["+k+"]="+oldHistory[k]);
                    newHistory[k]=oldHistory[k];
		}
            }
        }else{
	    System.out.println("Empty incoming history for:"+varCrt);
	    newHistory=new int[2];
	}
        newHistory[k]=crtMyselfPosition;
	k++;
        newHistory[k]=historyIDs[id];
	System.out.println("Adding to history: |"+crtMyselfPosition+":"+historyIDs[id]);
        return newHistory;
    }
    void buildLastSent(boolean differences[], Range domain[]){
	String varCrt;
	DVarHistory dVarHistory;
	for(int k=0; k<differences.length; k++){
	    if(!differences[k])
		continue;
	    varCrt=process.getVariable(k);
	    System.out.println("Is worth updating k:"+varCrt);
	    // updates the Range(k==id)
	    dVarHistory=new DVarHistory(domain[k]);
	    // updates the History(k==id)
	    dVarHistory.history=buildNewHistory(varCrt,k);
	    lastSent.put(varCrt, dVarHistory);
	}
    }
    // returns map(var:Range)
    // being called, synchronized by (iAmReady)
    // should not be synchronized by anything else
    DView different(ArrayList vars, Range[] domain, Hashtable vIDs, boolean[] differences){
        DView view=new DView();
        DVarHistory dVarHistory;
        for(int k=0;k<vars.size();k++){
            String varCrt;
            int id;
	    // find the internal id of the variable k 
	    // to send to current agent
            id=((IntObject)vIDs.get(varCrt=(String)(vars.get(k)))).getInt();
	    System.out.println("Build dView for:"+varCrt+" id="+id);
            if(differences[id]){
		System.out.println("Is worth updating:"+varCrt);
		dVarHistory=(DVarHistory)lastSent.get(varCrt);
		if(dVarHistory==null){
		    System.err.println(varCrt+": this should be in the lastSent");
		    if(lastSolution[id]!=emptyRange){
			System.err.println(varCrt+": found in lastSolution");
			dVarHistory=new DVarHistory(lastSolution[id]);
		    }
		    else continue;
		}
                view.put(varCrt,dVarHistory);
                //#System.out.println(varCrt+"=["+domain[id].getL()+","+domain[id].getU()+"]");
            } else
		System.out.println("Is not worth updating:"+varCrt);
        }
        if(view.size()!=0)
            return view;
	System.out.println("Empty dView");
        return null;
    }
    boolean waitOutGoing(){
	// System.out.println("waitOutGoing: waits for gotOutgoing");
	synchronized(gotOutgoing){
	    if(process.theEnd)
		return false;//exit
	    while(!gotOutgoing.request()){
		if(process.theEnd)
		    return false;//exit
		try {
		    try {
			System.out.println("Waiting outgoing...");
			gotOutgoing.wait();
			System.out.println("Got outgoing...");
		    }catch (InterruptedException e){
			return false;//exit
		    }
		}catch (Exception e){
		    System.out.println("Interrupted!");
		    e.printStackTrace();
		}
	    }
	}
	return true;
    }
    int getOutgoingNr(String var){
	if(!waitOutGoing())
	    // interrupted
	    return 0;
	ArrayList al=(ArrayList)extDependency.get(var);
	return (al==null)?0:al.size();
    }
    void negateIncoming(IAgentServer agent){
	Object sig=inComing.get(agent);
        if(sig==null){
            System.out.println("negateIncoming:error incoming");
	    return;
	}
        inComing.put(agent,no_signaled);
    }
    void registerIncoming(IAgentServer agent){
	if(agent==myself){
	    System.out.println("registerIncoming:getting from myself");
	    return; //send to myself
	}
	synchronized(waitedLinks){
	    Object sig=inComing.put(agent,signaled);
	    if(sig==null)
		System.out.println("registerIncoming:new incoming");
	    int posAdd=waitedLinks.indexOf(agent);
	    if(posAdd>=0){
		System.out.println("registerIncoming:freeing waitingLinks position:"+posAdd);
		waitedLinks.remove(posAdd);
		if(waitedLinks.size()<=0)
		    waitedLinks.notifyAll();
	    }
	}
    }
    boolean registerInComing(IncomingAgent agents[]){
        IAgentServer farAgent;
        int oldAgents=0,newAgents=0;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    if(!inComing.containsKey(farAgent)){
		inComing.put(farAgent,no_signaled);
		newAgents++;
	    }
	    else
		oldAgents++;
	}
        System.out.println("There were "+newAgents+" new incoming agents and "+oldAgents+" old ones");
        return true;
    }
    public boolean registerOutGoing(OutgoingAgent agents[]){
        IAgentServer farAgent;
        int oldAgents=0,newAgents=0;
        OutgoingAgent oa;
        for(int k=0;k<agents.length;k++){
	    farAgent=agents[k].getAgent();
	    oa=(OutgoingAgent)outGoing.get(farAgent);
	    if(oa==null) {
		outGoing.put(farAgent,agents[k]);
		ArrayList vars;
		vars=agents[k].variables;
		for(int v=0;v<vars.size();v++){
		    ArrayList extD;
		    extD=(ArrayList)extDependency.get(vars.get(v));
		    if(extD==null)
			extD=new ArrayList();
		    extD.add(farAgent);
		    extDependency.put(vars.get(v),extD);
		}
		newAgents++;
	    } else{
		// Should be unique!
		ArrayList variables=agents[k].variables;
		for(int j=0;j<variables.size();j++){
		    String s=(String)variables.get(j);
		    if(!oa.variables.contains(s)){
			System.out.println(": new s="+s);
			oa.variables.add(s);
			ArrayList extD;
			extD=(ArrayList)extDependency.get(s);
			if(extD==null)
			    extD=new ArrayList();
			extD.add(farAgent);
			extDependency.put(s,extD);
		    }else
			System.out.println(": old s="+s);
		}
		oldAgents++;
	    }
	}
	System.out.println("There were "+newAgents+" new outgoing agents and "+oldAgents+" old ones");
        return true;
    }
    public void startSearch(){
        Solve();//thread start
        return;
    }
    
    void killSolveThread(){
        /*@ deprecated */
        //process.stop();
	_ABT_SolverThread tmp=process;
	if(tmp==null)
	    return;
	// synchronised as a stupid trial to answer
	// a IllegalMonitor State Exception appeared
	// here in a test.
	try {
	    tmp.stopIt();
	    synchronized(externalRequest){
		try{
		    System.out.println("interrupting process:externalRequest");
		    tmp.interrupt();
		}catch(Exception e){
		    e.printStackTrace();
		    System.err.println("_ABT_Solver:kill:externalRequest:interrupt");
		}
	    }
	    // in case that processes in outGoing
	    // have just lost the previous signal
	    /*
	    synchronized(gotOutgoing){
		try{
		    System.out.println("interrupting process");
		    tmp.interrupt();
		}catch(Exception e){
		    e.printStackTrace();
		    System.err.println("_ABT_Solver:kill:gotOutgoing:interrupt");
		}
	    }
	    */
	} catch (IllegalMonitorStateException e) {
	    synchronized(System.err) {
		System.err.println("_ABT_Solver:kill:IllegalMonitorStateException");
	    }
	}
    }
    public void stopSession(){
        System.out.println("Kill solver thread");
        killSolveThread();
        System.out.println("Killing done...");
        lastSolution=null;
        return;
    }
    // used to internal tests requested in process by nogoods
    Range getExtRange(String var){
        if(extVariables.containsKey(var))
            return ((ExtVariable)extVariables.get(var)).range;
        return null;
    }

    // outGoing waited in nogood(
    IAgentServer getLast(DGetLast request){
	System.out.println("getLast:Looking for last");
	IAgentServer target=(IAgentServer)request.source;
	if(dSearch==null){
	    System.err.println("getLast:No dSearch!!");
	    return null;
	}
	int crtIndex=((IntObject)dSearch.agentOrder.get(target)).getInt();
	System.out.println("getLast:Index of myself: "+crtIndex);
	for(int k=crtIndex-1;k>=0;k--)
	    if(hasAnyWith_ABT_(((IAgentServer[])dSearch.sortedAgents)[k],request.guiltyV)){
		System.out.println("getLast:Found target at position: "+k);
		return ((IAgentServer[])dSearch.sortedAgents)[k];
	    }
	System.out.println("getLast:No last found");
	return null;
    }

    // enables the elimination of !owner at Nogoods
    boolean hasAnyWith_ABT_(IAgentServer agent, String[] variables){
	SVariable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getSVariables();
	System.out.println("hasAnyWith_ABT_:Size of agent variables="+svars.length);
	for(int k=0;k<svars.length;k++){
	    System.out.println("hasAnyWith_ABT_:Check var:"+k+" "+svars[k].getSVariable());
	    if(!isFirstOcc(svars[k],k)){
		System.out.println("hasAnyWith_ABT_:not first variable in _ABT_:"+svars[k].getSVariable());
		continue;
	    }
	    for(int kk=0;kk<variables.length;kk++){
		System.out.println("hasAnyWith_ABT_:Check against var:"+kk+" "+variables[kk]);
		if(variables[kk].equals(svars[k].getSVariable()))
		    return true;
	    }
	}
	System.out.println("hasAnyWith_ABT_:Not found");
	return false;
    }
    // if the variables occures for the first time at agent k
    boolean isFirstOcc(SVariable fVar, int crtIndex){
	// if not returning nogoods to last being a first
	if(!Utils.nogoodToLastFirst)
	    return true;
	if(Utils.firstOwned)
	    return fVar.isOwner();
	String[] vList=new String[1];
	vList[0]=fVar.getSVariable();
	for(int k=crtIndex-1;k>=0;k--)
	    if(hasAny(((IAgentServer[])dSearch.sortedAgents)[k],vList)){
		System.out.println("isFirstOcc:Found variable at agent: "+k);
		return false;
	    }
	System.out.println("isFirstOcc:It seems that this is the first occurence");
	return true;
    }

    boolean hasAny(IAgentServer agent, String[] variables){
	SVariable[] svars=((AgentData)dSearch.problemByAgent.get(agent)).getSVariables();
	System.out.println("hasAny:Size of agent variables="+svars.length);
	for(int k=0;k<svars.length;k++){
	    System.out.println("hasAny:Check var:"+k+" "+svars[k].getSVariable());
	    for(int kk=0;kk<variables.length;kk++){
		System.out.println("hasAny:Check against var:"+kk+" "+variables[kk]);
		if(variables[kk].equals(svars[k].getSVariable()))
		    return true;
	    }
	}
	System.out.println("hasAny:Not found");
	return false;
    }
    IAgentServer[] getAntecedents(DGetAntecedents antecedents){
	if(!waitOutGoing())
	    // interrupted
	    return null;
	ArrayList agents=new ArrayList();
	int id=antecedents.id;
	for(int k=id-1;k>=0;k--)
	    if(hasAny(((IAgentServer[])dSearch.sortedAgents)[k],antecedents.variables)){
		agents.add(((IAgentServer[])dSearch.sortedAgents)[k]);
		System.out.println("antecedent agent "+k);
	    }
	System.out.println("GetAntecedents");
	return (IAgentServer[])agents.toArray(new IAgentServer[0]);
    }
}
/*ID1000
  if(id>=0){
  // put the base range of the Original Variable
  view.put(guiltyV[k], process.getBaseRange(id));
  continue;
  }
  if(extVariables.containsKey(guiltyV[k])){
  ev=new DVarHistory(((ExtVariable)extVariables.get(guiltyV[k])).range);
  System.out.println("getNogood:adding extVariables "+guiltyV[k]+" as "+ev);
  view.put(guiltyV[k],ev);
  } else{
  System.err.println("getNogood:where is rhis variable from:"+guiltyV[k]);
  System.exit(1);
  }
*/
/*ID1001
  // if contains a premature value
  if(prematureNogood(dnogood)){
  System.out.println("insertConstraint:premature nogood");
  if(newOK.size()==0)
  System.err.println("premature nogood error somewhere!!!!!!!!");
  System.out.println("premature nogood detected");
  return true;
  }
  // if all the variables are 
  // updated consequence
  if(upToDateNogood(dnogood)){
  System.out.println("insertConstraint:upToDateNogood");
  return true;
  }
  System.out.println("insertConstraint:Outdated nogood detected");
*/
    // checks if this nogood is perfect consequence of all the internal knowledge consequence
/*
  /*
    boolean upToDateNogood(DNogood dnogood){
        DVarHistory dKnownVarHistory,dIncomingVarHistory;
	if(dnogood==null){
	    System.err.println("upToDateNogood:dnogood==null");
	    System.exit(1);
	}
        Hashtable view=dnogood.view;
	if(view==null){
	    System.err.println("upToDateNogood:view==null");
	    System.exit(1);
	}
        Iterator keys=(Iterator)view.keys();
	if(keys==null){
	    System.err.println("upToDateNogood:keys==null");
	    System.exit(1);
	}
        while(keys.hasNext()){
            String crtVar=(String)keys.next();
	    System.out.println("upToDateNogood:crtVar="+crtVar);
            dKnownVarHistory=(DVarHistory)varHistory.get(crtVar);
            dIncomingVarHistory=(DVarHistory)view.get(crtVar);
	    if(dIncomingVarHistory==null){
		System.err.println("upToDateNogood:dIncomingVarHistory==null");
		System.exit(1);
	    }
            int id;
	    id=process.getvID(crtVar);
            if(dKnownVarHistory==null){
                // if published from here
		if(!((dIncomingVarHistory.history==null)||(dIncomingVarHistory.history.length==0)))
		    if(dIncomingVarHistory.history[0]==crtMyselfPosition){
			if(id<0){
			    System.err.println("upToDateNogood:consequence that is not internal");
			    System.exit(1);
			}
			// upToDate or outDated?
			if(dIncomingVarHistory.history[1]!=historyIDs[id]){
			    System.out.println("upToDateNogood:old consequence");
			    return false;
			}
			System.out.println("upToDateNogood:direct conswequence :"+crtVar);
			continue;
		    }
                // while not sent from here and not in view
		System.out.println("upToDateNogood:never seen-:"+crtVar);
                continue; // never seen
            }
	    if(id>=0)
		if(dIncomingVarHistory.crtConsequence(dKnownVarHistory,crtMyselfPosition,historyIDs[id])){
		    System.out.println("upToDateNogood:consequence");
		    continue;
		}
		else return false;
            if(dKnownVarHistory.olderOrEqualThan(dIncomingVarHistory))
		System.out.println("upToDateNogood:older or equal");
		continue;
        }
	System.out.println("upToDateNogood:upToDateNogood");
        return true;
    }
*/
/*
    // checks if this nogood is newer than the OK?
    // true if newer false if older or consequence
    boolean prematureNogood(DNogood dnogood){
        DVarHistory dKnownVarHistory,dIncomingVarHistory;
	if(dnogood==null){
	    System.err.println("prematureNogood:dnogood=null");
	    System.exit(1);
	}
        Hashtable view=dnogood.view;
	if(view==null){
	    System.err.println("prematureNogood:view=null");
	    System.exit(1);
	}
        Iterator keys=(Iterator)view.keys();
	if(keys==null){
	    System.err.println("prematureNogood:keys=null");
	    System.exit(1);
	}
        while(keys.hasNext()){
            String crtVar=(String)keys.next();
	    System.out.println("prematureNogood:crtVar="+crtVar);
            dKnownVarHistory=(DVarHistory)varHistory.get(crtVar);
            dIncomingVarHistory=(DVarHistory)view.get(crtVar);
	    if(dIncomingVarHistory==null){
		System.err.println("prematureNogood:dIncomingVarHistory=null");
		System.exit(1);
	    }
            if(dKnownVarHistory==null){
                // if published from here
		if(!((dIncomingVarHistory.history==null)||
		     (dIncomingVarHistory.history.length==0))){
		    if(dIncomingVarHistory.history[0]==crtMyselfPosition){
			System.out.println("prematureNogood:first consequence-"+crtVar);
			continue;
		    }
		}
		// while not sent from here and not in view
		System.out.println("prematureNogood:never seen");
		return true;
		
            }
            int id;
	    id=process.getvID(crtVar);
	    if(id>=0)
		if(dIncomingVarHistory.crtConsequence(dKnownVarHistory,crtMyselfPosition,historyIDs[id])){
		    System.out.println("prematureNogood:consequence-"+crtVar);
		    continue;
		}
            // it is older but not because consequence
            if(dKnownVarHistory.olderThan(dIncomingVarHistory)){
		System.out.println("prematureNogood:me older");
                return true;
	    }
        }
        return false;
    }
*/
