package dcsp;
import java.util.*;
import dcsp.parameters.*;

class _ABT_SolverThread extends Thread {
    Problem problem;
    Object searchID=(Object)new DInt(0);
    _ABT_Solver solver;
    
    int variablesNr;
    // Nr of originalActiveYConstraintsNr
    int constraintsNr;
    // the index up to where all constraints are 
    // not changed by a nogood
    int lastReliableYConstraint=-1;
    // The current active constraints
    int yConstraintsNr;
    Range[][] domains=new Range[0][0]; //var stack
    Range[] crtBox;
    // initialized to the internal original domains
    // for the original variables
    Range[] originalDomains;
    YVariable[] variables; //pointers to variables
    Hashtable vIDs=new Hashtable();
    // here we have all the constraints whoose external
    // variables were not yet instantiated
    // YConstraints
    ArrayList waitingConstraints=new ArrayList();
    // contains all those original Constraints whose
    // external variables are already instantiated
    // YConstraints
    ArrayList activeConstraints=new ArrayList();
    // Those nogoods that are consistent with the view
    //ArrayList activeNogoods=new ArrayList();
    // Old nogoods base
    ArrayList oldNogoods=new ArrayList();
    //    IYConstraint[] yconstraints;
    ArrayList yconstraints;
    IYConstraint crtYConstraint; //the current YC
    // with the size of yConstraintsNr
    int[] order;
    int crtConstraint=-1, crtDomain=0;
    // announce that the end of the search was requested
    boolean theEnd=false;
    // ask the getNext to return once more the same
    boolean returnSame=false;
    // announces to resetContinuationPoints if a domain was expanded by an OK?
    boolean expanded=false;
    boolean nogoodRemoval=false;
    boolean noModifyingMessage;
    // test if the current process is reporting a solution
    boolean iAmReady=false;
    // announce the arrival of an up-to-date OK? after a nogood was sent
    boolean oKgot=false;
    public static final boolean TRACE_ON=true;

    class YVariable{
        public String name;
        public boolean init=false;
        public int owner; //-1=extern;0=inexistent;1=this
        //public int timestamp; //not implemented=last ok?
        //... propose: one ascending timestamp per variable with a "runda" rotating id
    }
    boolean isOwner(int k){
	return (variables[k].owner==1);
    }
    _ABT_SolverThread(Problem _problem, _ABT_Solver _solver){
        solver=_solver;
        problem=_problem;
    }
    public void stopIt(){
        theEnd=true;
    }
    public void run(){
	try{
	    init();
	    if(!theEnd){
		DCPR();
		System.out.println("End of _ABT_ thread");
	    }
	    try{
		((AgentServer)solver.myself).removeThreads();
	    }catch(Exception e){
		System.err.println("_ABT_SolverThread:run:removeThreads!!");
		System.err.println(e);
		e.printStackTrace();
	    }
	    // to avoid the second interrupt
	    synchronized(solver.gotOutgoing){
		try{
		    try{
			try{
			    String param="Agent: "+solver.problem.owner.name+" Protocol:"+solver.problem.crtProtocol+" File:"+solver.problem.owner.fileName;
			    System.out.println("sending IAMCLEAN:"+param);
			    AgentServer.oneWaySend(solver.broker,"IAMCLEAN",param,searchID);
			}catch(Exception ev){//java.io.InterruptedIOException:
			    String param="Agent:resend1: "+solver.problem.owner.name+" Protocol:"+solver.problem.crtProtocol+" File:"+solver.problem.owner.fileName;
			    System.out.println("sending IAMCLEAN:"+param);
			    AgentServer.oneWaySend(solver.broker,"IAMCLEAN",param,searchID);
			    synchronized(System.err){
				System.err.println("_ABT_SolverThread:run:sendCLEAN:interrupted?!");
				System.err.println(ev);
				ev.stackTracePrint();
			    }
			}
		    }catch(Exception ev){//java.io.InterruptedIOException:
			String param="Agent:resend2: "+solver.problem.owner.name+" Protocol:"+solver.problem.crtProtocol+" File:"+solver.problem.owner.fileName;
			System.out.println("sending IAMCLEAN:"+param);
			AgentServer.oneWaySend(solver.broker,"IAMCLEAN",param,searchID);
			synchronized(System.err){
			    System.err.println("_ABT_SolverThread:run:sendCLEAN:interrupted?!");
			    System.err.println(ev);
			}
		    }
		}catch(Exception ev){
		    synchronized(System.err){
			System.err.println("_ABT_SolverThread:run:sendCLEAN");
			System.err.println(ev);
			ev.printStackTrace();
		    }
		}
	    }
	}catch(Exception ex){
	    try{ // second interrupt
		try{
		    ((AgentServer)solver.myself).removeThreads();
		}catch(Exception e){
		    System.err.println("_ABT_SolverThread:run:removeThreads!!");
		    System.err.println(e);
		    e.printStackTrace();
		}
		synchronized(solver.gotOutgoing){
		    synchronized(System.err){
			ex.printStackTrace();
		    }
		    String param="Agent: "+solver.problem.owner.name+" Protocol:"+solver.problem.crtProtocol+" File:"+solver.problem.owner.fileName;
		    System.out.println("sending IAMCLEAN:"+param);
		    AgentServer.oneWaySend(solver.broker,"IAMCLEAN",param,searchID);
		}
	    }catch(Exception ex1){
		try{
		    synchronized(solver.gotOutgoing){
			synchronized(System.err){
			    ex1.printStackTrace();
			}
			String param="Agent:resend3 "+solver.problem.owner.name+" Protocol:"+solver.problem.crtProtocol+" File:"+solver.problem.owner.fileName;
			System.out.println("sending IAMCLEAN:"+param);
			AgentServer.oneWaySend(solver.broker,"IAMCLEAN",param,searchID);
		    }
		}catch(Exception ex2){
		    synchronized(System.err){
			System.err.println("_ABT_SolverThread:run:sendCLEAN");
			System.err.println(ex2);
			ex2.printStackTrace();
		    }
		}
	    }
	}
	System.gc();
	return;
    }
    void init(){
        buildDomainStack();
        buildConstraintReferences();
    }
    void buildDomainStack(){
        SVariable[] svariables;
        SetOfVariables sv;
        sv=problem.getSetOfVariables();
        svariables=sv.getSVariables();
        variablesNr=svariables.length;
            // variablesNr=sv.getVariablesNr();
        variables=new YVariable[variablesNr];
        constraintsNr=problem.getSetOfConstraints().getConstraintsNr();
        domains=new Range[constraintsNr+2][variablesNr];
        originalDomains=new Range[variablesNr];
        //crtBox=new Range[variablesNr];
        for(int k=0;k<variablesNr;k++){
            // should contain the timestamp of the last ok
            variables[k]=new YVariable();
            String varCrt=variables[k].name=svariables[k].getSVariable();
            vIDs.put(varCrt,new IntObject(k));
            originalDomains[k]=sv.getRange(varCrt);
            domains[0][k]=(Range)originalDomains[k].clone();
            System.out.println("get own:"+varCrt);
            variables[k].owner=sv.getOwner(varCrt);
            System.out.println("got own:"+varCrt+" "+variables[k].owner);
        }
    }
    // constructs an easy to reach _ABT_ fitted array of constraints
    ArrayList getYConstraints(){
        SetOfConstraints sc=problem.getSetOfConstraints();
        //constraintsNr=sc.getConstraintsNr();
        Constraint[] constraints=sc.getConstraints();
        ArrayList ycons= new ArrayList(constraintsNr);
        // IYConstraint[] ycons= new IYConstraint[constraintsNr];
        for(int k=0;k<constraintsNr;k++){
            IYConstraint crtCons=new YConstraint(constraints[k],this);
            //ycons[k]= crtCons;
            ycons.add(crtCons);
            if(crtCons!=ycons.get(k))
                System.out.println("Unexpected situation");
            // Normally should check for external variables
            activeConstraints.add(ycons.get(k));
        }
        // All are initialized, and no nogood
        yConstraintsNr=ycons.size();
        return ycons;
    }
    private void updateYConstraintReferences(IYConstraint yc){
        int vcrt,vNr,vID;
	if(yc==null){
	    System.err.println("EXIT-Update refferences for null");
	    System.exit(1);
	}
        // var nr. for constraint
        vNr=yc.getVariablesNr();
        for(vcrt=0;vcrt<vNr;vcrt++){
            System.out.println("Trying constraint  var "+vcrt);
            String vName;
            vName=yc.getVariable(vcrt);
            System.out.println("Trying constraint  var "+vcrt+" var name "+vName);
	    vID=getvID(vName);
	    yc.setID(vcrt,vID);
            System.out.println("Built constraint  var "+vName+" id "+vID);
        }
    }
    // Constraints nr. was set
    void buildConstraintReferences(){
        int k; //counter
        yconstraints=getYConstraints();
        order=new int[constraintsNr];
        for(k=0;k<constraintsNr;k++){
            order[k]=k;
            updateYConstraintReferences((IYConstraint)yconstraints.get(k));
        }
    }
    boolean amIReady(){
	return iAmReady;
    }
    _ABT_Solver getSolver(){
	return solver;
    }
    // !if ever keeping partial nogoods, then
    // !finish the implementation of YNogood::active(*)

    // parameter (String:DVarHistory)
    void reviewNogoods(Hashtable view){
	int k;
	YNogood crtNogood;
	System.out.println("reviewNogoods:start");
	int oldSize=oldNogoods.size();
	System.out.println("reviewNogoods. All: "+yConstraintsNr+" constr:"+constraintsNr);
	for(k=yConstraintsNr-1;k>=constraintsNr;k--){
	    // for all nogoods
	    System.out.println("reviewNogoods:k="+k);
	    crtNogood=(YNogood)yconstraints.get(k);
	    if(crtNogood.active(view)==0){
		System.out.println("Nogood "+k+" remains active");
	    }else{
		System.out.println("Nogood "+k+" is deactivated");
		nogoodRemoval=true;
		// decrement the extVariable's activation counter
		System.out.println("reviewNogoods: deactivate");
		crtNogood.deactivate();
		// It is inserted in a waiting queue
		// undoing the work in void nogood()
		System.out.println("reviewNogoods: remove");
		YNogood yn=(YNogood)yconstraints.remove(k);
		System.out.println("reviewNogoods: add");
		oldNogoods.add(yn);
		
		Range[][] newDomains=new Range[yConstraintsNr+1][];
		int newOrder[]=new int[yConstraintsNr-1];
		int c,o;
		System.out.println("reviewNogoods: begin");
		// Domains with one later
		for(c=0; c<=k; c++){
		    newDomains[c]=domains[c];
		}
		System.out.println("reviewNogoods: midi");
		yConstraintsNr--;
		if(lastReliableYConstraint>=yConstraintsNr){
		    lastReliableYConstraint=yConstraintsNr-1;
		    System.out.println("reviewNogoods:Removing the last");
		}
		for(; c<=yConstraintsNr+1; c++){
		    if(domains.length<=c+1){
			System.err.println("domains.length<=c+1!!!!");
			continue;
		    }
		    newDomains[c]=domains[c+1];
		}
		//yConstraintsNr decremented
		for(c=o=0;o<yConstraintsNr;o++,c++){
		    if(order[o]==k){
			c++;
			// announce elimination to 
			//   force backtracking
			if(lastReliableYConstraint>=o)
			    lastReliableYConstraint=o-1;
		    }
		    newOrder[o]=(order[c]<k)?order[c]:order[c]-1;
		}
		System.out.println("reviewNogoods: end");
		domains=newDomains;
		order=newOrder;
		System.out.println("reviewNogoods:lastReliableYConstraint:"+lastReliableYConstraint);
	    }
	}
	// from the last forward, not to change order
	for(k=oldSize-1;k>=0;k--){
	    System.out.println("reviewNogoods: end k="+k);
	    crtNogood=(YNogood)oldNogoods.get(k);
	    System.out.println("reviewNogoods: test k="+k);
	    if((crtNogood).active()==0){
		System.out.println("reviewNogoods: remove k="+k);
		YNogood yn=(YNogood)oldNogoods.remove(k);
		System.out.println("reviewNogoods: active k="+k);
		addActiveNogood(yn);
	    }
	}
    }
    void DCPR(){
        System.out.println("Solving!");
        PrintDomains(0,false);
        for(;;){
            DCPR(0);
	    // Tell that the first is not instantiated
	    setContext(-1);
            if(theEnd)
                return;
            // it may happen to change the first constraint
            // and to exit because of that
            if(lastReliableYConstraint<0) 
                continue;
            oKgot=false;
            solver.sendNogood();
            //  if an OK? that changes the view(nogoods or original) comes
            //  then "break"
            // insure that OK update originals
                //if (!waitOk(true))
                //  return;
            try{
                System.out.println("DCSP: waits for solver.getRestart()");
		synchronized(solver.getRestart()){
		    System.out.println("Going to sleep...");
		    for(;;) {
			if (!waitSignal(true))
			    return;
			if (oKgot)
			    break;
		    }
		    // expanded have no meaning here
		    initReconsiderations(); //(expanded=false)
		    System.out.println("Waking up...");
		}
            }catch(Exception e){
                e.printStackTrace();
                return;
            }
        }
    }
    // to the instantiation at each constr, up and incl. c
    // c-the min of lastReliable or the crtConstraint
    private void resetEverythingToCurrentInstantiation(int c){
	IYConstraint yc;
        Range[] instantiation; //crt instantiation

	solver.resetGuilty();
        for(int i=0;i<=c;i++) {
	    System.out.println("resetEverythingToCurrentInstantiation:Changing constraint: "+i);
	    if(i>=order.length){
		System.err.println("resetEverythingToCurrentInstantiation:Not so many YConstraints!!!:i="+i);
		continue;
	    }
	    if(order[i]>=yconstraints.size()){
		System.err.println("resetEverythingToCurrentInstantiation:Not so many YConstraints!!!:yc="+order[i]);
		continue;
	    }
            yc=(IYConstraint)yconstraints.get(order[i]);
            //add regions
            instantiation=getInstantiation(yc,domains[i+1]);
            // for nogoods
            if(i>=constraintsNr){
		System.out.println("resetEverythingToCurrentInstantiation:It is a nogood");
                // i== crtDomain-1 //for the crt constraint
                Range[] dom=getInstantiation(yc,domains[i]);
                yc.initDomain(dom);
            }else
                yc.resetContinuationPoints();           
	    System.out.println("resetEverythingToCurrentInstantiation:Reset mark");
            yc.resetMark(instantiation);
        }
	System.out.println("resetEverythingToCurrentInstantiation:End of remarking");
    }
    // to be checked only from:resetImpliedBoxesContinuationPoints, and handle request
    private boolean haveToBacktrack(boolean eq){
	if(eq&&(crtConstraint>=lastReliableYConstraint))
	    return true;
	if((!eq)&&(crtConstraint>lastReliableYConstraint))
	    return true;
	return false;
    }
    // If have to backtrack, then: resetEverythingToCurrentInstantiation(lastReliable) and set "returnSame" to request the getNext of the lastReliable return the same instantiation
    // If nogoodRemoval then everything should be reset to current instantiations excepting the case when the removed is not guilty(in externalVariables-never checked since last OK?)
    // If expanded then at least the expanded region of the cover should be reset(Should keep the old values of domains!)
    // parameter shows if should backtracking returning the same if the previous const is the first reliable-----perhaps it is more clean(easy) not to ever have the parameter false
    void resetImpliedBoxesContinuationPoints(boolean eq_param){
        System.out.println("resetImpliedBoxesContinuationPoints:Current constraint: "+crtConstraint);
        System.out.println("resetImpliedBoxesContinuationPoints:Last reliable constraint: "+lastReliableYConstraint);
	if(haveToBacktrack(eq_param)){
	    System.out.println("resetImpliedBoxesContinuationPoints:haveToBacktrack");
	    resetEverythingToCurrentInstantiation(lastReliableYConstraint);// the domains at each everyth is inst.
	    returnSame=true;
	    return;
	}
	if(nogoodRemoval){
	    nogoodRemoval=false;
	    System.out.println("resetImpliedBoxesContinuationPoints:nogoodRemoval");
          //if(anyGuiltyRemoved()){ //to be implemented!
	    System.out.println("resetImpliedBoxesContinuationPoints:anyGuiltyRemoved(consider...)");
	    resetEverythingToCurrentInstantiation(crtConstraint);
	    return; //}
	}
	if(expanded){
	    expanded=false;
	    System.out.println("resetImpliedBoxesContinuationPoints:expanded");
	    //in fact should reset only added regions
	    resetEverythingToCurrentInstantiation(crtConstraint);
	    return;
	}
	System.out.println("resetImpliedBoxesContinuationPoints:nothing changes");
    }
    void initReconsiderations(){
	expanded=false;
	nogoodRemoval=false;
    }
    // handle the oK and nogood requests
    boolean handleRequests(){
	//perhaps not needed to initialize expanded
	initReconsiderations(); //(expanded=false)
        System.out.println("Checking for message");
        if(solver.serveIfRequested()){
            resetImpliedBoxesContinuationPoints(false);
	    if(haveToBacktrack(false))
		return false;
            return feasible();
        }
        System.out.println("No message");
        return true;
    }
    Hashtable getvIDs(){
        return vIDs;
    }
    int getvID(String var){
	IntObject io=(IntObject)vIDs.get(var);
	if(io==null) return -1;
	else return io.getInt();
    }
    boolean allowedFeasible(){
        for(int k=0;k<variablesNr;k++)
            if (domains[crtDomain-1][k].size()<=0)
                return false;
        return true;
    }
    // Is the current domain emptied by external requests?
    boolean feasible(){
	System.out.println("feasible:crtDomain="+crtDomain+":lastReliableYConstraint="+lastReliableYConstraint);
	if(domains==null){
	    System.out.println("EXIT-feasible:domains==null");
	    System.err.println("EXIT-feasible:domains==null");
	    try{
		throw new Exception("domains==null");
	    }catch(Exception e){
		e.printStackTrace();
	    }
	    System.exit(1);
	}
	// if the nogoods have eliminated crtDomain
	if(crtDomain>=domains.length)
	    return false;
	Range[] dom=domains[crtDomain];
	if(dom==null){
	    System.out.println("EXIT-feasible:dom==null");
	    System.err.println("EXIT-feasible:dom==null at:"+crtDomain);
	    try{
		throw new Exception("dom==null");
	    }catch(Exception e){
		e.printStackTrace();
	    }
	    System.exit(1);
	}
        for(int k=0;k<variablesNr;k++){
	    System.out.println("feasible:k="+k);
	    if(dom[k]==null){
		System.out.println("feasible:empty k="+k+" !!!");
		if(crtDomain>=lastReliableYConstraint)
		    return false;
		System.err.println("EXIT-feasible:empty k="+k+" !!!");
		try{
		    throw new Exception("EXIT-feasible:empty k=");
		}catch(Exception e){
		    e.printStackTrace();
		}
		System.exit(1);
	    }
            if (dom[k].size()<=0)
                return false;
	}
        return true;
    }
    void PushDomains(){
        crtDomain++;
    }
    void PopDomains(){
        crtDomain--;
    }
    // called by solver to build the nogoods to send
    DVarHistory getBaseRange(int var){
        Range myRange= (Range)domains[0][var].clone();
	Class cMy=myRange.getClass();
	DVarHistory dVH=new DVarHistory(myRange);
	Class cDVH= dVH.getClass();
	if(cDVH.isAssignableFrom(cMy))
	    return (DVarHistory)myRange;
	System.out.println("TRANSFORM RANGE TO DVARHISTORY!"+cMy+" to "+dVH);
	return dVH;
    }
    // called by solver to build the nogoods to send
    DVarHistory getBaseRange(String var){
	int id=getvID(var);
	if(id>=0)
	    return getBaseRange(id);
	else{
	    System.err.println("getBaseRange:id<0");
	    return null;
	}
    }
    // called by solver to add in nogoods the variables
    // from original instance, modified by incoming
    void addInternalRestrictingVariables(ArrayList _variables){
	String var;
        // for All original variables
        for(int k=0;k<variablesNr;k++){
	    var=variables[k].name;
	    System.out.println("addInternalRestrictingVariables:deal with "+var);
            // when box, then box should appear in original!!
            // checks if argument more restricting than host
            if(originalDomains[k].restricting(domains[0][k])){
		System.out.println("addInternalRestrictingVariables:restricting "+var);
		// add if not already present
		if(!_variables.contains(var)){
		    System.out.println("addInternalRestrictingVariables:!contains:var="+var);
		    _variables.add(var);
		}else
		    System.out.println("addInternalRestrictingVariables:contains:var="+var);
	    }
	}
    }
    // insert somewhere this nogood
    // where=0 => insert in search
    // where=1 => insert in early
    // where=-1 > outdated
    /// once, "order" and "domains" may change to ArrayList
    void nogood(DNogood dnogood, int where, Object o){
        if(false/*where==0*/){
            YNogood yNogood=new YNogood(dnogood, this);
            updateYConstraintReferences(yNogood);
	    addActiveNogood(yNogood);
            // insertion done; now the search has to restart
        }else{
            YNogood yNogood=new YNogood(dnogood, this);
	    updateYConstraintReferences(yNogood);
	    // If fully active where instantiations in o
	    // have priority
	    if(yNogood.fullyActive((Hashtable)o)==0){
		System.out.println("process:nogood:adding active");
		addActiveNogood(yNogood);
	    }
	    else{
		System.out.println("process:nogood:adding inactive");
		oldNogoods.add(yNogood);
	    }
	}
    }
    void addActiveNogood(YNogood yNogood){
	registerModifyingMessage();
	//activeNogoods.add(yNogood);
	yconstraints.add(yNogood);
	// mark the nogoods counters ref vars
	yNogood.activate();
	Range[][] newDomains=new Range[yConstraintsNr+3][];
	int newOrder[]=new int[yConstraintsNr+1];
	int k=0;
	for(; k<yConstraintsNr; k++){
	    newDomains[k]=domains[k];
	    newOrder[k]=order[k];
	}
	// the last is the last-(old yConstraintsNr)
	newOrder[yConstraintsNr]=yConstraintsNr;
	yConstraintsNr++;
	newDomains[k]=domains[k];
	k++;// 
	newDomains[k]=domains[k];// two more than order
	newDomains[++k]=new Range[variablesNr];
	domains=newDomains;
	order=newOrder;
    }
    // var:dvarHist(range:int[])
    // returns true if any domain is expanded
    boolean ok(Hashtable view){
	//System.out.println("At OK? should check and if no range is enlarged then no domain and scannpoint should be reset");
        // after a nogood is sent, we can restart
        oKgot=true;
        Iterator keys=(Iterator)view.keys();
        String changed;
        while (keys.hasNext()){
            changed=(String)keys.next();
            IntObject io=(IntObject)vIDs.get(changed);
            if(io==null){
                System.out.println("External variable \""+changed+"\"");
                continue;
            }
            int id;
            id=io.getInt();
            variables[id].init=true;
            Range range=(Range)view.get(changed);
            System.out.println("variable "+changed+" id="+id+" range ["+range.getL()+","+range.getU()+"]");
	    // the domain is expanded
	    if(range.restricting(domains[0][id])){
		System.out.println("ok:expanded<-true");
		expanded=true;
	    }
	    System.out.println("ok:expanded="+((expanded)?"true":"false"));
            domains[0][id]=(Range)range.clone();
	    boolean interfere=false;
	    IYConstraint iyc;
            for(int c=1;c<=crtDomain;c++){
		if(c>lastReliableYConstraint+1)
		    break;
		if(!interfere){
		    iyc=getYConstraint(c-1);
		    if(iyc==null){
			System.err.println("ok:null_iyc at "+(c-1));
			break;
		    }
		    if(iyc.haveID(id)){
			interfere=true;
		    } else{
			domains[c][id]=(Range)((DVarHistory)range).getRange().clone();
			continue;
		    }
		}
                domains[c][id].restrict(range);
	    }
        }
	return expanded;
    }
    IYConstraint getYConstraint(int k){
	return 
	    (IYConstraint)yconstraints.get(order[k]);
    }
    void ReOrderConstraints(int k){
    }
    int getFurtherOccurenceNr(int id){
        int count=0;
        for(int k=crtConstraint+1;k<constraintsNr;k++){
            if(((IYConstraint)yconstraints.get(order[k])).haveID(id))
                count++;
        }
        return count;
    }
    int getOutgoingNr(int id){
	if(id<0){
	    System.out.println("Require Outgoing of:"+id);
	    return 0;
	}
        return solver.getOutgoingNr(getVariable(id));
   }
    void ReOrderVariables(){
	if(Utils.constrained){
	    int[] score=new int[crtYConstraint.getVariablesNr()];
	    for(int k=0;k<score.length;k++){
		int id=crtYConstraint.getID(k);
		if(id<0) //while not in extDependency at addLink
		    score[k]=0;
		else{
		    if(Utils.inversConstrained){
			score[k]=-constraintsNr*getOutgoingNr(id);
		    }else
			score[k]=constraintsNr*getOutgoingNr(id);
		}
		score[k]+=getFurtherOccurenceNr(id);
	    }
	    //structure results
	    int[] order=new int[score.length];
	    int[] invorder=new int[score.length];
	    getOrder(score,order,invorder);
	    crtYConstraint.setOrder(score, order, invorder);
	}
    }
    // reorder-most constrained last;
    void getOrder(int[] score, int[] order, int[] invorder){   // smallest first
        int size=score.length;
        for(int k=0;k<size;k++){
            int kk, count=0;//count-cite vin inainte?
            for(kk=0;kk<k;kk++)
                if(score[k]>=score[kk])
                    count++;
            for(kk++;kk<size;kk++)
                if(score[k]>score[kk])
                    count++;
            // most dependency last
            order[count]=k;//id of smallest!biggest first
            invorder[k]=count;//index of 0 first
        }
    }
    String getVariable(int id){
	if(id<0)
	    return null;
        return variables[id].name;
    }
    Range getRange(int id){
	return domains[0][id];
    }
    void PrintDomains(int level, boolean always){
        if(TRACE_ON || always){
            if(!always)
                System.out.println("Level "+level);
            Range[] dom=domains[level];
            for(int k=0;k<dom.length;k++)
                System.out.println(variables[k].name+"=variable["+k+"="+((IntObject)vIDs.get(variables[k].name)).getInt()+"]"+"\t=[ "+
                                   dom[k].getL()+"\t, "+dom[k].getU()+"\t]");
            System.out.println();
        }
    }
    void ReportSolution(){
        System.out.println("Solution:");
        PrintDomains(yConstraintsNr,true);
        solver.setSolution(domains[yConstraintsNr],vIDs);
    }
    void setContext(int ccrt){
        crtConstraint=ccrt;
	if(ccrt>=0)
	    crtYConstraint=(IYConstraint)yconstraints.get(order[crtConstraint]);
    }
    void init_Cover(int ccrt){
        setContext(ccrt);
        crtYConstraint.initCover();
        // For nogoods
        if(ccrt>=constraintsNr){
            Range[] dom=getInstantiation(crtYConstraint,domains[crtDomain-1]);
            crtYConstraint.initDomain(dom);
        }
        ReOrderVariables();
    }
    // get the box (allowed or instantiated) corresponding to the constraint
    Range[] getInstantiation(IYConstraint cons, Range[] instantiations){
        Range[] dom=new Range[cons.getVariablesNr()];
        for(int k=0; k<dom.length; k++){
            int id=cons.getID(k);
            //System.out.println("build var "+id+" "+variables[id].name);
            if (id>=0)
                dom[k]=instantiations[id];//allowed domains
            else
                // if ever using old nogoods
                // behaviour can be improved
                dom[k]=solver.getExtRange(cons.getVariable(k));
        }
        return dom;
    }
    // parameter: current constraint
    boolean GetNextBox(int ccrt){
        Range[] dom=getInstantiation(crtYConstraint,domains[crtDomain-1]);
        // crtBox length update (not needed?)
        crtBox=new Range[dom.length];
        /*
        dom=new Range[crtYConstraint.getVariablesNr()];
        for(int k=0; k<dom.length; k++)
            dom[k]=domains[crtDomain-1][crtYConstraint.getID(k)]; //allowed domains
        */
        return crtYConstraint.getNextBox(crtBox,dom);
    }
    void LoadDomains(){
        for(int k=0;k<variablesNr;k++)
            domains[crtDomain][k]=(Range)domains[crtDomain-1][k].clone();
    }
    void UpdateDomains(){
        int variablesConstraint=crtYConstraint.getVariablesNr();
        for(int k=0;k<variablesConstraint;k++){
            int id=crtYConstraint.getID(k);
            if(id>=0)
                // nogoods can be negative
                domains[crtDomain][id]=(Range)crtBox[k].clone();
        }
    }
    void setIAmReady(){
	iAmReady=true;
    }
    void registerModifyingMessage() {
	noModifyingMessage=false;
    }
    void DCPR(int ccrt){
        lastReliableYConstraint=ccrt;
        debugPrint();
        if(theEnd || !waitStep(true))
            return; //the End
	// better put it here, perhaps I become last
        System.out.println("Intend to check for message");
        if(!handleRequests())
            return;
	//perhaps a nogood is just eliminated from ccrt but no backtracking
	lastReliableYConstraint=ccrt;
        if(LastConstraint(ccrt)) {
            //l?boolean isLast=true;
	    try {
		ReportSolution();
		System.out.println("DCPR: waits for solver.rest");
		synchronized(solver.getRestart()) {
		    System.out.println("Going to sleep after solution...");
		    for(;;) {
			noModifyingMessage=true;
			while(noModifyingMessage) {
			    if (!waitSignal(true)) {
				iAmReady=false;
				return;
			    }
			    if(noModifyingMessage)
				System.out.println("DCPR:noModifyingMessage");
			}
			iAmReady=false;
			if (lastReliableYConstraint<ccrt) {
			    resetImpliedBoxesContinuationPoints(true);
			    System.out.println("DCPR:Constraint removed");
			    return;
			}
			if(feasible()) {
			    if (yConstraintsNr>ccrt) {
				//l?isLast=false;
				resetImpliedBoxesContinuationPoints(true);
				System.out.println("DCPR:Constraint added");
				//if(!feasible()) {
				//System.out.println("DCPR: But also OK? make me infeasible:return");
				//return;
				//}
				break;
			    }
			    // no need yet to resetImpliedBoxesContinuationPoints
			    System.out.println("still ok");
			    //PrintDomains(constraintsNr+1,true);
			    ReportSolution();
			}else {
			    resetImpliedBoxesContinuationPoints(true);
			    return;//l?break;
			}
		    }
		    System.out.println("Waking up...");
		}
		// perhaps a nogood has been added
		// in that case we simply continue
		//l?if(isLast)  return; 
	    } catch(Exception e){
		iAmReady=false;
		return;
	    }
	}
        // The nogoods may modify the Constraints Stack
        if(lastReliableYConstraint<ccrt){
            System.out.println("not reliable:return");
            return;
        }
        PushDomains();
        init_Cover(ccrt);
        while (GetNextBox(ccrt)){
            LoadDomains();
            UpdateDomains();
            
            PrintDomains(ccrt+1, false);//trace
            
            ReOrderConstraints(ccrt);
	    do{
		returnSame=false;
		DCPR(ccrt+1);
		if(lastReliableYConstraint<ccrt){ 
		    System.out.println("DCPR:have to backtrack:ccrt="+ccrt);
		    break;//break the do;
		}
		if((!feasible())) {
		    System.out.println("DCPR:no longer feasible:ccrt="+ccrt);
		    returnSame=false;
		    break;//perhaps ok?
		}
		if(returnSame){
		    // to correctly re-enter DCPR
		    setContext(ccrt);
		    System.out.println("DCPR:will return the same:ccrt="+ccrt);
		}
	    }while(returnSame);
            System.out.println("Return to level "+ccrt);
            // The nogoods may modify the Constraints Stack
            if(lastReliableYConstraint<ccrt) break;
            System.out.println("level "+ccrt+" ... Checking if allowed");
            if(!allowedFeasible()) break;//perhaps ok?
            System.out.println("Allowed");
            debugPrint();
            if(theEnd || !waitStep(true)){
                System.out.println("But the End");
                break; //the End
            }
            setContext(ccrt);
        }
        PopDomains();
    }
    private void debugPrint(){
        for(int k=0;k<=crtConstraint;k++){
            System.out.println("Constraint "+k+" of "+crtConstraint);
	    if(k>=order.length){
		System.out.println("This constraint was removed");
		continue;
	    }
            IYConstraint iyc=(IYConstraint)yconstraints.get(order[k]);
	    if(iyc==null){
		System.out.println("debugPrint:==null k="+k);
		continue;
	    }
	    iyc.Print();
        }
    }
    boolean LastConstraint(int nr){
        return nr>=yConstraintsNr;
    }
    // if parameter is true, then return false on interrupt
    boolean waitSignal(boolean end){
        System.out.print("Wait ok...");
        try {
            try {
                solver.waitSignal();
                System.out.println("restart");
            }
            catch (InterruptedException e){
		iAmReady=false;
                System.out.println("killed");
                if(end)
                    return false; //theEnd
            }
        } catch (IllegalMonitorStateException e2){
            System.out.println("waitSignal:error");
            e2.printStackTrace();
        }
        return true;
    }
    boolean waitStep(boolean end){
        try {
            if(problem.getAgent().waitStep())
                return true;
            else
                throw  new InterruptedException("");
        }
        catch (InterruptedException e){
            return false;
        }
    }
}

/*
    // Shuld deal with nogood removal
    //only if expanded
    void resetImpliedBoxesContinuationPoints(){
        System.out.println("resetImpliedBoxesContinuationPoints:Want to reset continuation up to constraint: "+crtConstraint);
        System.out.println("resetImpliedBoxesContinuationPoints:Last reliable constraint: "+lastReliableYConstraint);
        IYConstraint yc; 
        Range[] instantiation; //crt instantiation
	// first we treat the case when there was no expansion
	if(!expanded){
	    System.out.println("resetImpliedBoxesContinuationPoints:No domain was expanded=>no nogood removal, no reinitialisation");
	    // if we need to backtrack
	    if(crtConstraint>lastReliableYConstraint){
		System.out.println("resetImpliedBoxesContinuationPoints:Last reliable is reset");
		//In order to be able to get again the last solution.
		yc=(IYConstraint)yconstraints.get(lastReliableYConstraint);
		yc.initCover();
		// For nogoods(may happen at the first nogood)
		// if(isNogood)
		if(lastReliableYConstraint>=constraintsNr){
		    System.out.println("resetImpliedBoxesContinuationPoints:lastReliableYConstraint>=constraintsNr");
		    // the domain will be initialized with the allowed one(of the previous)
		    Range[] dom=getInstantiation(yc,domains[lastReliableYConstraint]);
		    yc.initDomain(dom);
		}
	    }
	    return;
	}
	expanded=false;
	// dealing with removed nogoods
	// the case eliminated in the second part of condition is treated next
        for(int i=0;
	    // for those that are before the last reliab
	    ((i<lastReliableYConstraint)&&
	     // but not after the current
	     (crtConstraint>=i))||
		// and for current if last reliab
		((i==lastReliableYConstraint)&&
		 (crtConstraint==lastReliableYConstraint));
	    i++) {
	    System.out.println("resetImpliedBoxesContinuationPoints:Checking constraint: "+i);
            yc=(IYConstraint)yconstraints.get(order[i]);
            //add regions
            instantiation=getInstantiation(yc,domains[i+1]);
            // for nogoods
            if(i>=constraintsNr){
		System.out.println("resetImpliedBoxesContinuationPoints:It is a nogood");
                // i== crtDomain-1 //for the crt constraint
                Range[] dom=getInstantiation(yc,domains[i]);
                yc.initDomain(dom);
            }else
                yc.resetContinuationPoints();           
	    System.out.println("resetImpliedBoxesContinuationPoints:Reset mark");
            yc.resetMark(instantiation);
        }
	System.out.println("resetImpliedBoxesContinuationPoints:End of remarking");
	// if we need to backtrack
	if(crtConstraint>lastReliableYConstraint){
	    System.out.println("resetImpliedBoxesContinuationPoints:Last reliable is reset");
	    yc=(IYConstraint)yconstraints.get(lastReliableYConstraint);
	    yc.initCover();
	    // For nogoods(may happen at the first nogood)
	    if(lastReliableYConstraint>=constraintsNr){
		System.out.println("resetImpliedBoxesContinuationPoints:lastReliableYConstraint>=constraintsNr");
		Range[] dom=getInstantiation(yc,domains[lastReliableYConstraint]);
		yc.initDomain(dom);
	    }
	}
    }
*/
